<?php
/*                                                       */
/* res_mod_prices.php - Modify reservation prices        */
/* $ID 186c - 2023-09-01 - brom $                        */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de>  */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it   */
/* under the terms the BROM CMS/BelCal license for free  */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */
/*                                                       */

// Create new admin object and print admin header
require('../../config/config.php');
require_once(BC_PATH.'/lib/classes/class.admin.php');
$admin = new admin('Reservations', 'reservations_modify','system');

// Get object id and section id
if(!isset($_GET['object_id']) OR !is_numeric($_GET['object_id']) OR !isset($_GET['section_id']) OR !is_numeric($_GET['section_id']) OR !isset($_GET['res_id']) OR !is_numeric($_GET['res_id'])) {
  header("Location: index.php");
  exit(0);
}
else {
  $object_id = $_GET['object_id'];
  $section_id = $_GET['section_id'];
  $res_id = $_GET['res_id'];
}
// Get language from calendar
if(!file_exists(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php')) {
  // no module language file exists for the language set by the user, include default module language file EN.php
  require(BC_PATH .'/modules/calendar/languages/EN.php');
}
else {
  // a module language file exists for the language defined by the user, load it
  require(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php');
}
if(file_exists(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php')) {
  require(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php');
}
if(LANGUAGE != 'EN'){ $dec_point = ','; $thousends = '.'; }else{ $dec_point = '.'; $thousends = ','; }
// Insert the holinames into CALTEXT
$get_holies = $datapdo->query("SELECT `holi_day`,`holiname` FROM `".TABLE_PREFIX."holidays` WHERE `language`='".LANGUAGE."'");
if($datapdo->numRows($get_holies)>0){
  while($holies = $datapdo->fetchRow($get_holies)){
    $CALTEXT['HOLI_'.$holies['holi_day']] = $holies['holiname'];
  }
}
$datapdo = new datapdo();
$get_calset = $datapdo->query("SELECT `countalldays`,`ext_persons`,`max_persons`,`inc_toddler`,`min_resdays` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$object_id' LIMIT 1");
$calset = $datapdo->fetchRow($get_calset);
$min_resdays = $calset['min_resdays'];
$showdays = $calset['countalldays'];
$extpersons = $calset['ext_persons'];
$maxpersons = $calset['max_persons'];
$inc_toddler = $calset['inc_toddler'];
// Check the user has permissions if come from directly link
$adm_users = $datapdo->get_one("SELECT `admin_users` FROM `".TABLE_PREFIX."objects` WHERE `object_id`='$object_id' LIMIT 1");
$admin_users = explode(',', str_replace('_', '', $adm_users));
if(!is_numeric(array_search($admin->get_user_id(), $admin_users))){
  $admin->print_error($MESSAGE['ADMIN']['INSUFFICIENT_PRIVELLIGES'],ADMIN_URL.'/index.php');
}
// Include the BC functions file
require_once(BC_PATH.'/lib/functions.php');
// Include the calculation finctions to bild table
require_once(BC_PATH.'/modules/calendar/calc_functions.php');
$go_url = ADMIN_URL.'/reservations/res_modify.php?object_id='.$object_id.ARGSO.'section_id='.$section_id.ARGSO.'res_id='.$res_id;
if(isset($_GET['backlist']) AND is_numeric($_GET['backlist'])){
  $backlist = $admin->get_get('backlist');
  switch ($backlist){
    case 6:
      $go_url = ADMIN_URL.'/reservations/listing.php';
      break;
    case 5:
      $go_url = ADMIN_URL.'/finances/index.php?bilbook=1';
      break;
    case 4:
      $go_url = ADMIN_URL.'/finances/index.php?details=1';
      break;
    case 3:
      $go_url = ADMIN_URL.'/reservations/calendar.php';
      break;
    case 2:
      $go_url = ADMIN_URL.'/reservations/resevations.php?object_id='.$object_id.ARGSO.'section_id='.$section_id;
      break;
    case 1:
      $go_url = ADMIN_URL.'/reservations/index.php#'.$section_id;
      break;
  }
}
$go_urljs = str_replace(ARGSO,ARGSOJS,$go_url);
// Get object title
$object_title = get_object_title($object_id);
// Get price settings for object
$get_price_set = $datapdo->query("SELECT `price_type`,`p_unit`,`roundprice` FROM `".TABLE_PREFIX."res_price_sets` WHERE `object_id`='$object_id' LIMIT 1");
$price_set = $datapdo->fetchRow($get_price_set);
$ppp = $price_set['price_type'];
$price_unit = $price_set['p_unit'];
$roundprice = $price_set['roundprice'];
// Get reservation
$get_resresult = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."reservations` WHERE `res_id`='$res_id' LIMIT 1");
$resresult = $datapdo->fetchRow($get_resresult);
$str_resid = $admin->zero_to_number($resresult['res_id']);
$status = $resresult['status'];
$strdata_a = gmdate(DATE_FORMAT,$resresult['res_start']);
$strdata_b = gmdate(DATE_FORMAT,$resresult['res_end']);
$cal_time_from = date('Gi',$resresult['res_start']);
$cal_time_to = date('Gi',$resresult['res_end']);
$date_days = ceil(($resresult['res_end']-$resresult['res_start'])/86400);
$plusday = 0;
if($showdays==1 AND $cal_time_from > $cal_time_to){ $plusday = 1; }
if($showdays==0 AND $cal_time_to > $cal_time_from){ $plusday = -1; }
$date_days = $date_days+$plusday;
$contingent = $resresult['contingent'];
$strcont = ($contingent > 1 ? ' / '.$contingent.' '.$CALTEXT['CONTINGENTS']:'');
$pers = $resresult['persons'];
$child = $resresult['children'];
$child2 = $resresult['toddler'];
$allchild = $child + $child2;
$strpers = ($pers > 0 ? ' / '.$pers.' '.($allchild>0?$CALTEXT['ADULTS']:$CALTEXT['PERSONS']):'');
$strchild = ($child > 0 ? ' / '.$child.' '.$CALTEXT['CHILDREN']:'');
$strchild2 = ($child2 > 0 ? ' / '.$child2.' '.$CALTEXT['TODDLER']:'');
$allpers = $pers + $child;
if($inc_toddler > 0){ $allpers = $allpers + $child2; }
$extpers = $allpers - $maxpersons + $extpersons;
// Patch for old reservations
$pers = ($pers > 0?$pers:1);
$allpers = ($allpers > 0?$allpers:1);
// Chack we have a correctly email
$is_email = false;
$client = $resresult['client_id'];
$get_email = $datapdo->query("SELECT `email` FROM `".TABLE_PREFIX."address` WHERE `client_id`='$client' AND `email`!='' LIMIT 0,1");
if($datapdo->numRows($get_email) > 0){
  $etemp = $datapdo->fetchRow($get_email);
  $email = $etemp['email'];
}
else{
  $email = $resresult['mail'];
}
if(!empty($email) AND $admin->validate_email($email)){ $is_email = true; }
// Check we have updated the field in res_price_calc
$new_field = array('fixed_price'=>0,'storno_days'=>0);
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_calc`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='fixed_price'){ $new_field['fixed_price'] = 1; }
  if($row[0]=='storno_days'){ $new_field['storno_days'] = 1; }
}
foreach($new_field AS $fldK => $fldV){
  if($fldV==0){
    switch ($fldK){
      case 'fixed_price':
        $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_calc` ADD `fixed_price` DECIMAL( 11,2 ) NOT NULL AFTER `res_days`");
        break;
      case 'storno_days':
        $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_calc` ADD `storno_days` INT NOT NULL AFTER `storno_price`");
        // Set all old reservations the storno_days to res_days
        $datapdo->query("UPDATE `".TABLE_PREFIX."res_price_calc` SET `storno_days`=`res_days`");
        break;
    }
  }
}
// Add table for frieefield texts
$freefields = "CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."res_text_fflds` ( `freefld_id` INT NOT NULL auto_increment,"
         . " `object_id` INT NOT NULL DEFAULT '0',"
         . " `section_id` INT NOT NULL DEFAULT '0',"
         . " `res_id` INT NOT NULL DEFAULT '0',"
         . " `item_id` VARCHAR(10) NOT NULL DEFAULT '',"
         . " `label` TEXT NOT NULL DEFAULT '',"                    // The label for calculation freefield
         . " PRIMARY KEY ( `freefld_id` )"
         . " )";
$datapdo->query($freefields);
// Patch to error insert
$datapdo->query("DELETE FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_days`='0'");
// Get reservation calculator
$get_rescalc = $datapdo->query("SELECT `res_days`,`total_price`,`paid_price`,`fixed_price`,`storno_price`,`storno_days` FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$res_id' LIMIT 1");
$rescalc = $datapdo->fetchRow($get_rescalc);
$res_days = $rescalc['res_days'];
$res_tp = $rescalc['total_price'];
$res_pp = $rescalc['paid_price'];
$fixed_price = $rescalc['fixed_price'];
$res_op = ($fixed_price>0?($fixed_price-$res_pp):($res_tp - $res_pp));
$book_tp = 0;
$book_tp_fix = 0;
$paycontrol = $datapdo->get_one("SELECT `paycontrol` FROM `".TABLE_PREFIX."res_paymentset` WHERE `object_id`='$object_id' LIMIT 1");
$disable_pmod = ($paycontrol > 0?' disabled':'');
// Get all invoices except discounts because need it for js script
$get_invoices = $datapdo->query("SELECT `invoice_id`,`item_id`,`quantity`,`single_price`,`fix` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id'");
$discs = array();
$alldiscs = 0;
while($invoices = $datapdo->fetchRow($get_invoices)){
  if(substr($invoices['item_id'],0,4) == 'DISC'){
    $discs[$invoices['invoice_id']] = $invoices['quantity'];
    $alldiscs++;
    continue;
  }
  $m = $invoices['quantity'];
  $p = $invoices['single_price'];
  if($invoices['fix']==1){ $book_tp_fix = $book_tp_fix + ($m * $p); }
  else{
    if(substr($invoices['item_id'],0,4) == 'SEAS' OR substr($invoices['item_id'],0,4) == 'HOLI'){
      $book_tp = $book_tp + ($m * $p);
    }
  }
}
if($fixed_price > 0){ $print_bookgp = number_format($book_tp_fix,2,$dec_point,$thousends); }
else{ $print_bookgp = number_format($book_tp,2,$dec_point,$thousends); }
// Output the header
?>
<script type="text/javascript">
var book_price = <?php echo $book_tp; ?>;
var oldgp_arr = new Array();
var book_price_reset = <?php echo $book_tp; ?>;
var disc_ids = <?php echo $alldiscs; ?>;
var disc_array = new Array();
var olddisc_array = new Array();
var dec_point = '<?php echo $dec_point; ?>';
var thousends = '<?php echo $thousends; ?>';
var repl_th = '/\\'+thousends+'/g';
<?php
if($roundprice==1){
  echo 'var roundit = true;';
}
else{
  echo 'var roundit = false;';
}
$i = 0;
foreach($discs as $did => $dv){
  echo 'disc_array['.$i.']= new Array('.$did.','.$dv.');'."\n";
  echo 'olddisc_array['.$i.']= new Array('.$did.','.$dv.');'."\n";
  $i++;
}
?>
function calc_newdiscount(newm,did){
     var newmulti = newm / 100;
     var new_gp = book_price * newmulti;
     if(roundit==true){ new_gp = Math.round(new_gp * 20)/20; }
     var dgpid = document.getElementById('dgp_'+did);
     var new_gp_str = String(new_gp);
     new_gp_str = new_gp_str.replace(/\./g,dec_point);
     dgpid.value = set_priceformat(new_gp_str);
     for(ii=0;ii < disc_ids;ii++){
        if(disc_array[ii][0] == did) disc_array[ii][1] = newm;
     }
     show_new_calc_button(1);
};
function set_ffld_quantity(v,id){
    var oldquantity = $("#quantity_"+id).val();
    var newquantity = 0;
    if(v != ""){
        $("#quantity_"+id).val(1);
        newquantity = 1;
    }
    else{ $("#quantity_"+id).val(0); }
    if(oldquantity != newquantity){ show_new_calc_button(1); }
};
function calc_numberformat(elem,oldgp,m,id,isbook){
     if(!oldgp_arr[id]){
        oldgp_arr[id] = oldgp;
     }
     var p_str = elem.value;
     var gpid = document.getElementById('gp_'+id);
     var p_arr = p_str.split(dec_point);
     if(!p_arr[0]){ p1 = '0'; }
     else{
        p1 = p_arr[0];
        p1 = p1.replace(repl_th,'');
     }
     if(!p_arr[1]){ p2 = '00'; }
     else{ p2 = p_arr[1]; }
     var p = parseFloat(p1 + '.' + p2);
     var newp = p;
     if(roundit==true){ newp = Math.round(p * 20)/20; }
     var newgp = m * newp;
     var pstr = String(newp);
     pstr = pstr.replace(/\./g,dec_point);
     if(roundit==true){ newgp = Math.round(newgp * 20)/20; }
     if(isbook==true){
       book_price = book_price - oldgp_arr[id] + newgp;
       if(roundit==true){ book_price = Math.round(book_price * 20)/20; }
       var book_price_str = String(book_price);
       book_price_str = book_price_str.replace(/\./g,dec_point);
       if(document.getElementById('book_gp')){
         document.getElementById('book_gp').value = set_priceformat(book_price_str);
       }
     }
     oldgp_arr[id] = newgp;
     var newgp_str = String(newgp);
     newgp_str = newgp_str.replace(/\./g,dec_point);
     elem.value = set_priceformat(pstr);
     gpid.value = set_priceformat(newgp_str);
     <?php if($fixed_price==0){ ?>
     for(i=0;i < disc_ids;i++){
       var iid = disc_array[i][0];
       var iqu = disc_array[i][1];
       calc_newdiscount(iqu,iid);
     }
     <?php } ?>
     show_new_calc_button(1);
};
function show_ffldvat_calc_button(pstr){
     var p_arr = pstr.split(dec_point);
     if(!p_arr[0]){ p1 = '0'; }
     else{
        p1 = p_arr[0];
        p1 = p1.replace(repl_th,'');
     }
     if(!p_arr[1]){ p2 = '00'; }
     else{ p2 = p_arr[1]; }
     var p = parseFloat(p1 + '.' + p2);
     if(p>0){ show_new_calc_button(1); }
};
function set_newvat_calc_button(spid,gpstr,m,newvat,oldvat,isb){
     var spstr = $("#single_price_"+spid).val();
     var p_arr = spstr.split(dec_point);
     if(!p_arr[0]){ p1 = '0'; }
     else{
        p1 = p_arr[0];
        p1 = p1.replace(repl_th,'');
     }
     if(!p_arr[1]){ p2 = '00'; }
     else{ p2 = p_arr[1]; }
     var p = parseFloat(p1 + '.' + p2);
     if(p>0){
         var newsingle_p = spstr;
         var pricelink = "<?php echo ADMIN_URL; ?>/reservations/setnewsingleprice.php?invid="+spid+"&newvat="+newvat;
         $("#noBox").load(pricelink, function(result) {
             newsingle_p = result;
             if(newsingle_p != spstr){
                 var el = $("#single_price_"+spid);
                 var ogp = gpstr;
                 el.val(newsingle_p);
                 elid = document.getElementById("single_price_"+spid);
                 calc_numberformat(elid,ogp,m,spid,isb);
             }
         });
     }
     else if(newvat!=oldvat){ show_new_calc_button(1); }
};
function set_new_storno_days(r,days){
     var stornolink = "<?php echo ADMIN_URL; ?>/reservations/setnewstornoprice.php?res="+r+"&newstornodays="+days;
     $("#noBox").load(stornolink, function(result) {
         if(stornop=='error'){ stornop = '0,00'; }
         var stornop = result;
         $("#storno_price").val(stornop);
         show_new_calc_button(1);
     });
};
function set_new_stornoprice(r,sprice){
     var sprice_array = sprice.split(dec_point);
     if(!sprice_array[0]){ p1 = '0'; }
     else{
        p1 = sprice_array[0];
        p1 = p1.replace(repl_th,'');
     }
     if(!sprice_array[1]){ p2 = '00'; }
     else{ p2 = sprice_array[1]; }
     var p = parseFloat(p1 + '.' + p2);
     var stornolink = "<?php echo ADMIN_URL; ?>/reservations/setnewstornoprice.php?res="+r+"&newstorno="+p;
     $("#noBox").load(stornolink, function(result) {
         if(stornop=='error'){ stornop = '0,00'; }
         var stornop = result;
         $("#storno_price").val(stornop);
         show_new_calc_button(1);
     });
};
function show_new_calc_button(onoff){
     var calcbutton = document.getElementById('calcbtn');
     var totalprice = document.getElementById('totalpr');
     if(onoff > 0){
       totalprice.className = 'hide';
       calcbutton.className = 'row_b';
       if($('#showprovision').length){ $('#showprovision').hide(); }
       if(document.getElementById('topaypr')){
         document.getElementById('topaypr').style.visibility = 'hidden';
       }
       if(document.getElementById('sender')){
         document.getElementById('sender').className = 'hide';
       }
     }
     else{
       book_price = book_price_reset;
       oldgp_arr = new Array();
       disc_array = olddisc_array;
       calcbutton.className = 'hide';
       totalprice.className = 'row_b';
       if(document.getElementById('topaypr')){
         document.getElementById('topaypr').style.visibility = 'visible';
       }
       if(document.getElementById('sender')){
         document.getElementById('sender').className = '';
       }
     }
};
function set_priceformat(xp){
     var x_array = xp.split(dec_point);
     var x1 = '';
     var x2 = '';
     if(!x_array[0]){
         x1 = '0';
     }
     else{
         x1 = x_array[0];
         x1 = x1.replace(repl_th,'');
     }
     if(!x_array[1]){
         if(x1.length > 6){
             x2 = x1.substr(x1.length-2,x1.length);
             x1 = x1.substr(0,x1.length-2);
         }
         else{
             x2 = '00';
         }
     }
     else{
         x2 = x_array[1];
     }
     if(x2.length < 2){
         x2 = x2 + '0';
     }
     var len1x1 = (x1.substr(0,1)=='-'?7:6);
     if(x1.length > len1x1){
         x1 = x1.substr(0,lenx1);
     }
     var len2x1 = (x1.substr(0,1)=='-'?4:3);
     if(x1.length > len2x1){
         x1 = x1.substr(0,x1.length -3 ) + thousends + x1.substr(x1.length -3,x1.length);
     }
     return x1 + dec_point + x2.substr(0,2);
};
function calc_paid_price(el){
    var p = el.value;
    el.value = set_priceformat(p);
    /*show_new_calc_button(1);*/
};
</script>
<h2><?php echo $object_title; ?></h2>
<h3><?php echo $CALTEXT['MODIFY_RESPRICES'].': '.$str_resid; ?></h3>
<p><?php echo $TEXT['TERMIN_START'].': '.$strdata_a.' / '.$TEXT['TERMIN_END'].': '.$strdata_b; ?></p>
<p><?php echo $date_days.' '.($showdays==1?$TEXT['TERMIN_ANZ']:$TEXT['TERMIN_ANZN']).$strcont.$strpers.$strchild.$strchild2; ?></p>

<form name="reservation" action="<?php echo ADMIN_URL; ?>/reservations/res_save_prices.php" method="post">
  <input type="hidden" value="<?php echo $object_id; ?>" name="object_id" />
  <input type="hidden" value="<?php echo $section_id; ?>" name="section_id" />
  <input type="hidden" value="<?php echo $res_id; ?>" name="res_id" />
<?php
  if(isset($backlist) AND $backlist > 0){
    echo '<input type="hidden" value="'.$backlist.'" name="backlist" />';
  }
  $price_array = array('res_days'=>$res_days,'date_days'=>$date_days,'book_prices1'=>array(),'book_prices2'=>array(),'book_prices3'=>array(),'book_prices_fix'=>array(),'more_price'=>array(),'adds_price'=>array(),'ffld_price'=>array(),'more_price_fix'=>array(),'adds_price_fix'=>array(),'holi_price'=>array(),'discounts'=>array(),'ext_pers2'=>0,'total_price'=>0,'fixed_price'=>0,'preprice'=>0,'confirm'=>0,'p_unit'=>'EUR','fp_info'=>'');
  $price_unit = $datapdo->get_one("SELECT `p_unit` FROM `".TABLE_PREFIX."res_price_sets` WHERE `section_id`='$section_id' LIMIT 1");
  $get_preprice = $datapdo->get_one("SELECT `preprice` FROM `".TABLE_PREFIX."res_price_sets` WHERE `section_id`='$section_id' LIMIT 1");
  $price_array['p_unit']=$price_unit;
  $price_array['res_days']=$res_days;
  $price_array['date_days']=$date_days;
  $price_array['fixed_price']=$fixed_price;
  $price_array['total_price']=$res_tp;
  $price_array['paid_price']=$res_pp;
  $totalforpre = ($fixed_price>0?$fixed_price:$res_tp);
  $extprice = get_external($res_id);
  $totalforpre =  $totalforpre - $extprice;
  $price_array['pre_price']=get_preprice($object_id,$totalforpre,$res_id,$extprice);
  if($fixed_price == 0){
    // Check have old fixed price
    $get_old_fix = $datapdo->query("SELECT `invoice_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id' AND `fix`='1' AND `item_id`='SPECIAL' AND `single_price`>'0' LIMIT 0,1");
    if($datapdo->numRows($get_old_fix)>0){
      echo '<table cellpadding="5" cellspacing="0" border="0" align="center" width="100%">';
      echo '<tr><td width="30%">&nbsp;</td><td width="70%" align="right">';
      echo '<input name="restorefix" id="restorefix" type="checkbox" onclick="if(this.checked=true){this.form.submit();}" /><label for="restorefix">'.$CALTEXT['RESTORE_OLD_FIX'].'</label>';
      echo '</td></tr></table>'."\n";
    }
  }
  else{
    // Set normal booking if have special price
    echo '<table cellpadding="5" cellspacing="0" border="0" align="center" width="100%">';
    echo '<tr><td width="30%">&nbsp;</td><td width="70%" align="right">';
    echo '<input name="deletefix" id="deletefix" type="checkbox" onclick="if(this.checked=true){this.form.submit();}" /><label for="deletefix">'.$CALTEXT['DELETE_FIX'].'</label>';
    echo '</td></tr></table>'."\n";
  }

  if($price_array['fixed_price']>0){
    $get_inv = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id' AND `fix`='1' ORDER BY `item_id`");
    if($datapdo->numRows($get_inv) > 0){
      while($inv = $datapdo->fetchRow($get_inv)){
        $id = $inv['invoice_id'];
        $inv_id = $inv['item_id'];
        $m = $inv['quantity'];
        $sp = $inv['single_price'];
        $fix = $inv['fix'];
        $ex = $inv['external'];
        $ppp = $inv['ppp'];
        $ita = explode('_',$inv_id);
        $inv_type = $ita[0];
        switch ($inv_type){
          case 'SPECIAL':
            $price_array['book_prices_fix'][$inv_id]=array($m,$sp,$ppp,$ex,$id);
            break;
          case 'ADDS':
            $price_array['adds_price_fix'][$ita[1]]=array($m,$sp,$ppp,$ex,$id);
            break;
          case 'MORE':
            $price_array['more_price_fix'][$ita[1]]=array($m,$sp,$ppp,$ex,$id);
            break;
        }
      }
    }
    // Add the prices from freefields
    $get_inv = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id' AND `item_id` LIKE 'FFLD%' ORDER BY `item_id`");
    if($datapdo->numRows($get_inv) > 0){
      while($inv = $datapdo->fetchRow($get_inv)){
        $id = $inv['invoice_id'];
        $inv_id = $inv['item_id'];
        $m = $inv['quantity'];
        $sp = $inv['single_price'];
        $fix = $inv['fix'];
        $ex = $inv['external'];
        $ppp = $inv['ppp'];
        $ita = explode('_',$inv_id);
        $inv_type = $ita[0];
        $price_array['ffld_price'][$ita[1]]=array($m,$sp,$ppp,$ex,$id);
      }
    }
  }
  else{
    // Get the bookings from invoice
    $get_inv = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id' AND `item_id` LIKE '%SEASON%' AND `fix`='0' ORDER BY `item_id`");
    if($datapdo->numRows($get_inv) > 0){
      while($inv = $datapdo->fetchRow($get_inv)){
        $id = $inv['invoice_id'];
        $inv_id = $inv['item_id'];
        $m = $inv['quantity'];
        $sp = $inv['single_price'];
        $ppp = $inv['ppp'];
        $ita = explode('_',$inv_id);
        $inv_type = $ita[2];
        $ita_id = $ita[0].'_'.$ita[1];
        switch ($inv_type){
          case '1':
            $price_array['book_prices1'][$ita_id]=array($m,$sp,$ppp,0,$id);
            break;
          case '2':
            $price_array['book_prices2'][$ita_id]=array($m,$sp,$ppp,0,$id);
            break;
          case '3':
            $price_array['book_prices3'][$ita_id]=array($m,$sp,$ppp,0,$id);
            break;
        }
      }
    }
    $get_inv = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id' AND (`item_id` LIKE '%ADDS%' OR `item_id` LIKE '%MORE%' OR `item_id` LIKE '%FFLD%' OR `item_id` LIKE '%HOLI%') AND `fix`='0' ORDER BY `item_id`");
    if($datapdo->numRows($get_inv) > 0){
      while($inv = $datapdo->fetchRow($get_inv)){
        $id = $inv['invoice_id'];
        $inv_id = $inv['item_id'];
        $m = $inv['quantity'];
        $sp = $inv['single_price'];
        $ppp = $inv['ppp'];
        $ex = $inv['external'];
        $ita = explode('_',$inv_id);
        $inv_type = $ita[0];
        switch ($inv_type){
          case 'ADDS':
            $price_array['adds_price'][$ita[1]]=array($m,$sp,$ppp,$ex,$id);
            break;
          case 'MORE':
            $price_array['more_price'][$ita[1]]=array($m,$sp,$ppp,$ex,$id);
            break;
          case 'FFLD':
            $price_array['ffld_price'][$ita[1]]=array($m,$sp,$ppp,$ex,$id);
            break;
          case 'HOLI':
            $init_year = gmdate('Y',time());
            if($ita[1] < 400){
              $chk_year = $resresult['res_start'];
              while($chk_year < $resresult['res_end']){
                $init_day = gmdate('z',$chk_year)+1;
                if($ita[1] == $init_day){ $init_year = gmdate('Y',$chk_year); }
                $chk_year +=86400;
              }
            }
            $price_array['holi_price'][$ita[1]]=array($m,$sp,$ppp,$init_year,$id);
            break;
        }
      }
    }
    $get_inv = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id' AND `item_id` LIKE '%DISC%' ORDER BY `item_id`");
    if($datapdo->numRows($get_inv) > 0){
      while($inv = $datapdo->fetchRow($get_inv)){
        $id = $inv['invoice_id'];
        $inv_id = $inv['item_id'];
        $m = $inv['quantity'];
        $sp = $inv['single_price'];
        $ita = explode('_',$inv_id);
        $price_array['discounts'][$ita[1]]=array($m,$sp,$id);
      }
    }
  }
  $ptable_array = build_price_table($price_array,$object_id,$section_id,$res_id,$pers,$child,$child2,'newcalc',false,'',$disable_pmod);
  $ptable = $ptable_array['CALC'];
  echo $ptable;
  // Get the provision if is set this object
  if($admin->get_permission('resbilling_view')){
    $preprovision = get_provision_calc($object_id,$res_id);
    if($preprovision != NULL){ echo '<p id="showprovision">'.$preprovision[0].'</p>'; }
  }
?>

  <table cellpadding="5" cellspacing="0" border="0" align="center" width="100%">
  <tr>
    <td width="50%">
      <input type="button" name="back" value="<?php echo $TEXT['BACK']; ?>" style="width: 99%;" onclick="window.location='<?php echo $go_urljs; ?>'" />
    </td>
    <?php
    if($paycontrol > 0){
      $paymentlink = ADMIN_URL.'/reservations/mod_payment.php?object_id='.$object_id.ARGSOJS.'section_id='.$section_id.ARGSOJS.'res_id='.$res_id.ARGSOJS.'backlist='.(isset($backlist)?$backlist:'1').ARGSOJS.'backdial=2';
    ?>
    <td width="50%">
      <input type="button" name="reset" value="<?php echo $CALTEXT['PAYING']; ?>" style="width: 99%;" onclick="window.location='<?php echo $paymentlink; ?>';" />
    </td>
    <?php }else{ ?>
    <td width="50%">
      <input type="reset" name="reset" value="<?php echo $TEXT['RESET']; ?>" style="width: 99%;" onclick="show_new_calc_button(0);" />
    </td>
    <?php } ?>
  </tr>
  </table>
</form>
<?php
// Include the form to send mail with template
$tpl1disabled = (($status>0)?'':' disabled');
$tpl2disabled = ($status==3?' selected="selected"':' disabled');
$tpl4disabled = ($status==0?' selected="selected"':' disabled');
$tpl5disabled = ($res_pp>0?'':' disabled');
$tpl6disabled = ($price_array['paid_price']>0?'':' disabled');
echo '<div id="sender" style="width:100%"><hr /><h3>'.($is_email == true?$CALTEXT['SEND_EMAIL']:$CALTEXT['PRINT_DOKU']).'</h3>';
?>
  <form name="opensender" action="<?php echo ADMIN_URL; ?>/reservations/mod_sendmail.php" method="post">
    <input type="hidden" name="res_id" value="<?php echo $res_id; ?>" />
    <input type="hidden" name="back" value="2" />
    <table cellpadding="5" cellspacing="0" border="0" align="center" width="100%">
      <tr>
        <td width="230"><?php echo $TEXT['TEMPLATE']; ?>:</td>
        <td>
          <select name="tpl" style="width: 99%">
            <option<?php echo $tpl1disabled; ?> value="1"><?php echo $CALTEXT['EMAIL_TPL_1']; ?></option>
            <option<?php echo $tpl2disabled; ?> value="2"><?php echo $CALTEXT['EMAIL_TPL_2']; ?></option>
            <option value="3"><?php echo $CALTEXT['EMAIL_TPL_3']; ?></option>
            <option<?php echo $tpl4disabled; ?> value="4"><?php echo $CALTEXT['EMAIL_TPL_4'].' / '.$CALTEXT['EMAIL_TPL_41']; ?></option>
            <option<?php echo $tpl5disabled; ?> value="5"><?php echo $CALTEXT['EMAIL_TPL_5']; ?></option>
            <option<?php echo $tpl6disabled; ?> value="6"><?php echo $CALTEXT['EMAIL_TPL_6']; ?></option>
            <?php if($is_email == true){ ?>
            <option value="0"><?php echo $CALTEXT['EMAIL_TPL_0']; ?></option>
            <?php } ?>
          </select>
        </td>
        <td width="240" align="right">
          <input style="width:98%;" name="sendmail" type="submit" value="<?php echo $TEXT['OPEN'].'/'.$TEXT['SEND']; ?>" />
        </td>
      </tr>
    </table>
  </form>
  </div>
<?php
// Print admin footer
$admin->print_footer();

?>