<?php
/*                                                       */
/* calc_functions.php - Functions for price calculation  */
/* $ID 214 - 2023-09-01 - brom $                         */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */
/*                                                       */

// Must include code to stop this file being access directly
if(defined('BC_PATH') == false){ exit("Cannot access this file directly"); }

// Tell the script the functions are loaded
if(!defined('CALCULATION_LOADED')){ define('CALUCULATION_LOADED',true); }
// Check the field pretype
$newfield = false;
$newfield2 = false;
$newfield3 = false;
$newfield4 = false;
$newfield5 = false;
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_sets`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='pretype'){ $newfield = true; }
  if($row[0]=='roundprice'){ $newfield2 = true; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_calc`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='pre_price'){ $newfield3 = true; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_adds`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='isold'){ $newfield4 = true; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_more`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='isold'){ $newfield5 = true; }
}
if($newfield == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_sets` ADD `pretype` TINYINT(1) NOT NULL AFTER `preprice`");
  // Update type for all preprice > 1 to 1
  $datapdo->query("UPDATE `".TABLE_PREFIX."res_price_sets` SET `pretype`='1' WHERE `preprice`>'1'");
}
if($newfield2 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_sets` ADD `roundprice` TINYINT(1) NOT NULL AFTER `preprice`");
}
if($newfield3 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_calc` ADD `pre_price` DECIMAL( 11,2 ) NOT NULL AFTER `res_days`");
  // Set first pre_prices like payings into table
  $get_payings = $datapdo->query("SELECT `res_id`,`payprice_pre` FROM `".TABLE_PREFIX."res_payments` WHERE `payprice_pre`>'0'");
  if($datapdo->numRows($get_payings)>0){
    while($payings = $datapdo->fetchRow($get_payings)){
      $datapdo->query("UPDATE `".TABLE_PREFIX."res_price_calc` SET `pre_price`='".$payings['payprice_pre']."' WHERE `res_id`='".$payings['res_id']."' LIMIT 1");
    }
  }
  // Set all other reservation to current pre prices
  $get_otherres = $datapdo->query("SELECT `object_id`,`res_id`,`total_price`,`fixed_price` FROM `".TABLE_PREFIX."res_price_calc` WHERE `pre_price`='0' AND (`total_price`>'0' OR `fixed_price`>'0') AND `storno_price`='0'");
  if($datapdo->numRows($get_otherres)>0){
    while($otherres = $datapdo->fetchRow($get_otherres)){
      $o = $otherres['object_id'];
      $r = $otherres['res_id'];
      $p = ($otherres['fixed_price']>0?$otherres['fixed_price']:$otherres['total_price']);
      $pre = get_preprice($o,$p,$r,0,true);
    }
  }
}
if($newfield4 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_adds` ADD `isold` TINYINT(1) NOT NULL");
}
if($newfield5 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_more` ADD `isold` TINYINT(1) NOT NULL");
}

function get_prices($from_day=0,$to_day=0,$obj=0,$persons=0,$children=0,$toddler=0,$opt=array(),$adrid=0){
	global $datapdo;
	global $admin;
	global $TEXT;
	// include the module calendar language file exists for the language set by the user (e.g. DE, EN)
	if(!file_exists(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php')) {
		// no module language file exists for the language set by the user, include default module language file EN.php
		require(BC_PATH .'/modules/calendar/languages/EN.php');
	}
	else {
		// a module language file exists for the language defined by the user, load it
		require(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php');
	}
	if(file_exists(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php')) {
		require(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php');
	}
	$adds_extern = 0;
	$adds_total = 0;
	$more_total = 0;
	$persons = ($persons==0?1:$persons);  // if we have no field with persons we get 0 but it does not work
	$allpers = $persons+$children+$toddler;
	$org_to_day = $to_day;
	$res_days = ceil(($to_day - $from_day) / 86400);
	if($res_days == 0){ $res_days = 1; $to_day = $to_day + 86400; }
	$price_section = 0;
	$return_array = array('res_days'=>$res_days,'date_days'=>$res_days,'book_prices1'=>array(),'book_prices2'=>array(),'book_prices3'=>array(),'book_prices_fix'=>array(),'more_price'=>array(),'adds_price'=>array(),'more_price_fix'=>array(),'adds_price_fix'=>array(),'holi_price'=>array(),'discounts'=>array(),'total_price'=>0,'fixed_price'=>0,'package'=>0,'pre_price'=>0,'preprice'=>0,'confirm'=>0,'p_unit'=>'EUR','fp_info'=>'','ffld_price'=>array());
	if($obj > 0){
		// Check the object has calendar and set this section
		$check_calendar_section = check_is_belcal($obj);
		if(is_array($check_calendar_section)){
			$price_section = $check_calendar_section[0];
		}
		else{
			// Check we have multical and set Object to section
			if(NULL !== get_cal_sector($obj)){ $price_section = $obj; }
		}
	}
	if($price_section==0 OR $from_day==0 OR $to_day==0 OR $admin->validate_key2(BC_LICENSE_KEY)==false)return $return_array;
	$get_cal_set = $datapdo->query("SELECT `calculator`,`confirm_days`,`countalldays`,`time_from`,`time_to`,`max_persons`,`inc_toddler`,`ext_persons` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$price_section' LIMIT 1");
	$cal_set = $datapdo->fetchRow($get_cal_set);
	$calc_type = $cal_set['calculator'];
	$return_array['confirm'] = $cal_set['confirm_days'];
	$noext_pers = ($cal_set['inc_toddler']==1?0:$toddler);
	$countalldays = $cal_set['countalldays'];
	$def_persons = ($cal_set['max_persons']+$noext_pers-$cal_set['ext_persons']);
	$ext_persons = ($allpers>$def_persons?$allpers - $def_persons:0);
	$calcnights = true;
	$daynight = $TEXT['TERMIN_ANZN'];
	if($cal_set['countalldays']>0){
		$calcnights = false;
		$daynight = $TEXT['TERMIN_ANZ'];
		if($cal_set['time_from']>$cal_set['time_to']){
			$res_days++;
			$to_day = $to_day + 86400;
		}
	}
	else{
		if($cal_set['time_to']>$cal_set['time_from']){
			$res_days--;
			$to_day = $to_day - 86400;
		}
	}
	$dres_days = $res_days;
	$return_array['date_days']=$dres_days;
	$return_array['res_days']=$res_days;
	switch ($calc_type){
		case '2':
			if(function_exists('get_totalprice')){
				$total_price = get_totalprice($from_day,$to_day,$obj,$persons,$children,$opt);
				$return_array['total_price'] = $total_price;
			}
			break;
		case '1':
			// Get the settings like section
			$price_settings = get_iprice_settings($price_section);
			$return_array['p_unit'] = $price_settings['p_unit'];
			$multiplicator1 = 0;
			$multiplicator2 = 0;
			$multiplicator3 = -1;
			if($price_settings['price_type']>0){
				// Get the children discount if available
				if($children > 0){
					$get_disc_child = $datapdo->query("SELECT `percent` FROM `".TABLE_PREFIX."res_discounts` WHERE `section_id`='$price_section' AND `discount_type`='0' AND `percent`>'0' LIMIT 1");
					if($datapdo->numRows($get_disc_child)>0){
						$disc_child = $datapdo->fetchRow($get_disc_child);
						$multiplicator2 = (100 - $disc_child['percent']) / 100;
					}
				}
				if($toddler > 0){
					$get_disc_child2 = $datapdo->query("SELECT `percent` FROM `".TABLE_PREFIX."res_discounts` WHERE `section_id`='$price_section' AND `discount_type`='4' AND `percent`>'0' LIMIT 1");
					if($datapdo->numRows($get_disc_child2)>0){
						$disc_child2 = $datapdo->fetchRow($get_disc_child2);
						$multiplicator3 = (100 - $disc_child2['percent']) / 100;
					}
				}
				$multiplicator1 = $persons;
			}
			else{
				if($cal_set['inc_toddler']==0){ $contpers = $allpers-$toddler; }
				else{ $contpers = $allpers; }
				$multiplicator1 = get_contingents($price_section,$contpers);
			}
			$staggp = 'p0';
			if($price_settings['staggering']=='1'){
				if($res_days>=$price_settings['p_stagg1']){
					$staggp = 'p1';
				}
				if($res_days>=$price_settings['p_stagg2']){
					$staggp = 'p2';
				}
				if($res_days>=$price_settings['p_stagg3']){
					$staggp = 'p3';
				}
				if($res_days>=$price_settings['p_stagg4']){
					$staggp = 'p4';
				}
			}
			$seas = ($price_settings['price_seas']=='1'?true:false);

			// Get price for reservation days and add it to book_prices
			$countday = $from_day;
			$temp_sp = 0;
			$quantity = 0;
			$temp_sp_name = 'SEASON_A';
			$total = 0;
			$total_fix = 0;
			$total_holi = 0;
			$end_day = $to_day - 86400;
//			while($countday<$old_to_day){
				// Check the min res days for seasons
				$mindays = get_season_mindays($price_section,$from_day,$end_day);
				if($res_days < $mindays){
					$adddays = ($mindays-$res_days)*86400;
					$to_day = $to_day + $adddays;
					$res_days = $mindays;
					$return_array['res_days'] = $res_days;
					$return_array['fp_info'] = $CALTEXT['MIN_INFO_SHORT'].'&nbsp;'.$res_days.'&nbsp;'.$daynight.'!';
				}
//				$countday = $countday + 86400;
//			}
			$countday = $from_day;
			$currdayseas = array();
			$currseascount = 0;
			$currdayseas[$currseascount] = $temp_sp_name;
			while($countday<$to_day){
				$currseascount++;
				$sp = get_season_price($price_section,$countday,$staggp,$seas);
				$sp_name = (!empty($sp[0])?$sp[0]:$temp_sp_name);
				if(is_numeric(array_search($sp_name,$currdayseas)) AND $currdayseas[$currseascount-1] != $sp_name){ $currdayseas[$currseascount] = $sp_name.substr($sp_name,-1); }
				else{ $currdayseas[$currseascount] = $sp_name; }
				$sp_name = $currdayseas[$currseascount];
				switch ($price_settings['seas_modus']){
					case 1:
						if($temp_sp < $sp[1]){
							$temp_sp_name = $sp_name;
							$temp_sp = $sp[1];
						}
						break;
					case 2:
						if($temp_sp == 0 OR $temp_sp > $sp[1]){
							$temp_sp_name = $sp_name;
							$temp_sp = $sp[1];
						}
						break;
					case 0:
					default:
						if(!isset($return_array['book_prices1'][$sp_name])){ $return_array['book_prices1'][$sp_name] = array(0,0,$price_settings['price_type']); }
						if($multiplicator2 > 0 AND !isset($return_array['book_prices2'][$sp_name])){ $return_array['book_prices2'][$sp_name] = array(0,0,$price_settings['price_type']); }
						if($multiplicator3 > -1 AND !isset($return_array['book_prices3'][$sp_name])){ $return_array['book_prices3'][$sp_name] = array(0,0,$price_settings['price_type']); }
						$quantity = $return_array['book_prices1'][$sp_name][0] + $multiplicator1;
						$return_array['book_prices1'][$sp_name] = array($quantity,$sp[1],$price_settings['price_type']);
						if($multiplicator2 > 0){
							$quantity = $return_array['book_prices2'][$sp_name][0] + $children;
							$ch_pricetmp = $multiplicator2 * $sp[1];
							$ch_price = round($ch_pricetmp,2);
if($price_settings['roundprice']==1){ $ch_price = round(($ch_pricetmp*2),1)/2; }else{ $ch_price = $ch_pricetmp; }
							$return_array['book_prices2'][$sp_name] = array($quantity,$ch_price,$price_settings['price_type']);
						}
						if($multiplicator3 > -1){
							$quantity = $return_array['book_prices3'][$sp_name][0] + $toddler;
							$ch_pricetmp = $multiplicator3 * $sp[1];
							$ch_price2 = round($ch_pricetmp,2);
if($price_settings['roundprice']==1){ $ch_price2 = round(($ch_pricetmp * 2),1)/2; }
							$return_array['book_prices3'][$sp_name] = array($quantity,$ch_price2,$price_settings['price_type']);
						}
						break;
				}
				// Get the adds of holidays
				$holi_total = 0;
				$holi_array = get_holi_prices($price_section,$countday,$allpers);
				if(NULL !== $holi_array){
					$return_array['holi_price'][$holi_array[0]] = array($holi_array[1],$holi_array[2],$holi_array[3],$holi_array[4]);
					$total_holi = $total_holi + ($holi_array[1] * $holi_array[2]);
				}
				$countday = $countday + 86400;
			}
			if($temp_sp > 0){
				$quantity = $multiplicator1 * $res_days;
				$return_array['book_prices1'][$temp_sp_name] = array($quantity,$temp_sp,$price_settings['price_type']);
				if($multiplicator2 > 0){
					$quantity = $children * $res_days;
					$ch_price = $multiplicator2 * $temp_sp;
					$return_array['book_prices2'][$sp_name] = array($quantity,$ch_price,$price_settings['price_type']);
				}
			}
			$total_array = $return_array['book_prices1'];
			foreach($total_array AS $k => $v){
				$total = $total + ($v[0]*$v[1]);
			}
			$total_array = $return_array['book_prices2'];
			foreach($total_array AS $k => $v){
				$total = $total + ($v[0]*$v[1]);
				//$total_fix = $total_fix + ($v[0]*$v[1]);
			}
			$total_array = $return_array['book_prices3'];
			foreach($total_array AS $k => $v){
				$total = $total + ($v[0]*$v[1]);
				//$total_fix = $total_fix + ($v[0]*$v[1]);
			}
			$return_array['total_price'] = $total + $total_holi;
			// Get fixed price if exists
			$fixed = get_fixed_price($from_day,$org_to_day,$price_section,$persons,$children);
			$inc_adds = array();
			$inc_more = array();
			if($fixed['fp'] > 0){
				$return_array['fixed_price']=$fixed['fp'] + $total_fix;
				if(!isset($return_array['book_prices_fix']['SPECIAL'])){ $return_array['book_prices_fix']['SPECIAL'] = array(1,$fixed['fp'],$fixed['fp_id']); }
				if(!empty($fixed['inc_adds'])){ $inc_adds = explode(',',$fixed['inc_adds']); }
				if(!empty($fixed['inc_more']) OR $fixed['inc_more']=='0'){ $inc_more = explode(',',$fixed['inc_more']); }
				$inc_name = '';
				if(count($inc_adds)>0){
					foreach($inc_adds AS $key => $val){
						$get_n = get_name_addkey($val,'adds',$price_section);
						if(trim($get_n)!=''){
							$inc_name .= (empty($inc_name)?' '.$CALTEXT['INCLUSIVE']:',').' '.$get_n;
						}
					}
				}
				if(count($inc_more)>0){
					foreach($inc_more AS $key => $val){
						$get_n = get_name_addkey($val,'more',$price_section);
						if(trim($get_n)!=''){
							$inc_name .= (empty($inc_name)?' '.$CALTEXT['INCLUSIVE']:',').' '.$get_n;
						}
					}
				}
				$return_array['fp_info'] = $inc_name;
				$return_array['package'] = $fixed['fp_id'];
			}
			// Before adds set the price for discounts
			$base_of_disc = $return_array['total_price'];
			// Get additional prices like adds
			$adds_total = 0;
			$adds_total_fix = 0;
			$adds_extern = 0;
			$adds_filter = get_adds2_prices($price_section,$from_day,$to_day,$calcnights,$allpers,$children,$toddler,$ext_persons,'res_price_adds');
			if(NULL === $adds_filter){ $adds_filter = array(); }
			$adds_array = get_adds_prices($price_section,$dres_days,$calcnights,$allpers,$children,$toddler,$ext_persons,'res_price_adds',$adds_filter);
			if(NULL !== $adds_array){
				foreach($adds_array AS $k => $v){
					$adds_total = $adds_total + ($v[0] * $v[1]);
					if($v[3]==1){ $adds_extern = $adds_extern + ($v[0] * $v[1]); }
					if($fixed['fp']>0){
						if(!is_numeric(array_search($k,$inc_adds))){
							$adds_total_fix = $adds_total_fix + ($v[0] * $v[1]);
						}
						else{
							$v[1] = 0;
						}
						$return_array['adds_price_fix'][$k] = $v;
					}
				}
				$return_array['adds_price'] = $adds_array;
			}
			$return_array['total_price'] = $return_array['total_price'] + $adds_total;
			$return_array['fixed_price'] = $return_array['fixed_price'] + $adds_total_fix;
			// Get additional prices like more with the same function
			$more_total = 0;
			$more_total_fix = 0;
			$more_array = get_adds_prices($price_section,$dres_days,$calcnights,$allpers,$children,$toddler,0,'res_price_more',$opt);
			if(NULL !== $more_array){
				foreach($more_array AS $k => $v){
					$more_total = $more_total + ($v[0] * $v[1]);
					if($v[3]==1){ $adds_extern = $adds_extern + ($v[0] * $v[1]); }
					if($fixed['fp']>0){
						if(in_array($k,$inc_more)){
							$v[1] = 0;
						}
						else{
							$more_total_fix = $more_total_fix + ($v[0] * $v[1]);
						}
						$return_array['more_price_fix'][$k] = $v;
					}
				}
				$return_array['more_price'] = $more_array;
			}
			$return_array['total_price'] = $return_array['total_price'] + $more_total;
			$return_array['fixed_price'] = $return_array['fixed_price'] + $more_total_fix;
//			$base_of_disc = $return_array['total_price'] - $adds_extern;
			$disc_array = get_discounts($price_section,$base_of_disc,$from_day,$adrid);
			$discount_total = 0;
			if(count($disc_array) > 0){
				foreach($disc_array AS $k => $v){
					$return_array['total_price'] = $return_array['total_price'] - $v[1];
					$discount_total += $v[1];
				}
				$return_array['discounts'] = $disc_array;
			}
			break;
		case '0':
		default:
			// Nothing to do
			break;
	}
	// Get the preprice if available
	$preprice = (isset($price_settings['preprice'])?$price_settings['preprice']:0);
	if($return_array['fixed_price']>0){ $pre_base = $return_array['fixed_price']; }else{ $pre_base = $return_array['total_price']; }
	$alladds = $adds_total+$more_total;
	$return_array['pre_price'] = get_preprice($obj,$pre_base,0,$alladds);
	$return_array['preprice'] = $return_array['pre_price'];
	return $return_array;
}
function get_iprice_settings($o){
	global $datapdo;
	$get_sets = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_price_sets` WHERE `section_id`='$o' LIMIT 0,1");
	if($datapdo->numRows($get_sets)>0){ return $datapdo->fetchRow($get_sets); }
	else{ return NULL; }
}
function get_contingents($o,$p){
	global $datapdo;
	if($p==0){ $p=1; }
	$p_per_cont = $datapdo->get_one("SELECT `max_persons` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$o' LIMIT 1");
	if($p_per_cont == 0){ $p_per_cont = $p; }
	$retcont = ceil($p / $p_per_cont);
	return $retcont;
}
function get_extcontingents($o,$p,$c){
	global $datapdo;
	$retextcont = 0;
	if($p==0){ $p=1; }
	$get_pers_cont = $datapdo->query("SELECT `max_persons`,`ext_persons` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$o' AND `ext_persons`>'0' LIMIT 1");
	if($datapdo->numRows($get_pers_cont)>0){
		$pers_cont = $datapdo->fetchRow($get_pers_cont);
		$ext_per_cont = $pers_cont['ext_persons'];
		$def_per_cont = $pers_cont['max_persons']-$ext_per_cont;
		$noext_pers = $def_per_cont * $c;
		$ext_pers = ($p - $noext_pers);// * $c;
		$retextcont = ceil($ext_pers / $ext_per_cont);
		$retextcont = ($retextcont<0?0:$retextcont);
	}
	return $retextcont;
}
function get_season_mindays($o,$day_from,$day){
	global $datapdo;
	$init_year = gmdate('Y',$day);
	$day_of_year = gmdate('z',$day)+1;
	$ret = 0;
	$allow_min = 0;
	if(gmdate('L',$day)==1 AND $day_of_year > 59){ $day_of_year--; }
	$get_seas_min = $datapdo->query("SELECT `min_resdays`,`allow_min` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$o' AND `season_start`<='$day_of_year' AND `season_end`>='$day_of_year' AND `season_year`='$init_year' LIMIT 0,1");
	if($datapdo->numRows($get_seas_min)>0){
		$seas_min = $datapdo->fetchRow($get_seas_min);
		$allow_min = $seas_min['allow_min'];
		$ret = $seas_min['min_resdays'];
	}
	else{
		$get_seas_min = $datapdo->query("SELECT `min_resdays`,`allow_min` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$o' AND `season_start`<='$day_of_year' AND `season_end`>='$day_of_year' AND `season_year`='0' LIMIT 0,1");
		if($datapdo->numRows($get_seas_min)>0){
			$seas_min = $datapdo->fetchRow($get_seas_min);
			$allow_min = $seas_min['allow_min'];
			$ret = $seas_min['min_resdays'];
		}
	}
	if($allow_min == 0 AND $ret == 0){
		// Check the default mindays
		$get_seas_min = $datapdo->query("SELECT `min_resdays`,`allow_min` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$o' AND `season_start`='0' AND `season_end`='0' LIMIT 1");
		if($datapdo->numRows($get_seas_min)>0){
			$seas_min = $datapdo->fetchRow($get_seas_min);
			$allow_min = $seas_min['allow_min'];
			$ret = $seas_min['min_resdays'];
		}
	}
	if($ret > 0 AND $allow_min == 2){
		// Check first the contingent this section
		$cont = $datapdo->get_one("SELECT `max_bookings` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$o' LIMIT 1");
		// Check the reservations before and alfter
		$resafter = 0;
		$resbefore = get_res_before($o,$day_from,$cont);
		if($resbefore>0){
			$checkafter = $resbefore + ($ret * 86400);
			$resafter = get_res_after($o,$checkafter,$day,$cont);
		}
		if($resbefore > 0 AND $resafter > 0){
			$days_between = intval(($resafter-$resbefore)/86400);
			if($days_between < $ret){ $ret = 0; }
		}
	}
	return $ret;
}
function get_season_minallow($o,$day_from,$day_to){
	global $datapdo;
	$init_year = gmdate('Y',$day_to);
	$day_of_year = gmdate('z',$day_to)+1;
	$ret = 0;
	$allow_min = 0;
	if(gmdate('L',$day_to)==1 AND $day_of_year > 59){ $day_of_year--; }
	$get_seas_min = $datapdo->query("SELECT `allow_min` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$o' AND `season_start`<='$day_of_year' AND `season_end`>='$day_of_year' AND `season_year`='$init_year' LIMIT 0,1");
	if($datapdo->numRows($get_seas_min)>0){
		$seas_min = $datapdo->fetchRow($get_seas_min);
		$allow_min = $seas_min['allow_min'];
	}
	else{
		$get_seas_min = $datapdo->query("SELECT `allow_min` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$o' AND `season_start`<='$day_of_year' AND `season_end`>='$day_of_year' AND `season_year`='0' LIMIT 0,1");
		if($datapdo->numRows($get_seas_min)>0){
			$seas_min = $datapdo->fetchRow($get_seas_min);
			$allow_min = $seas_min['allow_min'];
		}
	}
	if($allow_min == 0){
		// Check the default mindays
		$get_seas_min = $datapdo->query("SELECT `allow_min` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$o' AND `season_start`='0' AND `season_end`='0' LIMIT 1");
		if($datapdo->numRows($get_seas_min)>0){
			$seas_min = $datapdo->fetchRow($get_seas_min);
			$allow_min = $seas_min['allow_min'];
		}
	}
	return $allow_min;
}
function get_res_before($o,$from,$c=1){
	global $datapdo,$admin;
	$returndate = 0;
	$chkC = 0;
	$find_res_before = $datapdo->query("SELECT `res_end`,`contingent` FROM `".TABLE_PREFIX."reservations` WHERE `section_id`='$o' AND `res_end`<='$from' AND `status`>'0' ORDER BY `res_end` DESC LIMIT 0,".$c);
	if($datapdo->numRows($find_res_before)>0){
		while($getbefore = $datapdo->fetchRow($find_res_before)){
			$before = $getbefore['res_end'];
			$chkC += $getbefore['contingent'];
			if($chkC < $c){
				$chk_before = date("d.m.Y",($before-86400));
				$resultbefore = $admin->check_res_date($chk_before,$o,1);
				if($resultbefore==0){ return $before; }
			}
			else{ $returndate = $before; break; }
		}
	}
	return $returndate;
}
function get_res_after($o,$chkafter,$end,$c=1){
	global $datapdo,$admin;
	$returndate = 0;
	$chkC=0;
	$find_res_after = $datapdo->query("SELECT `res_start`,`contingent` FROM `".TABLE_PREFIX."reservations` WHERE `section_id`='$o' AND `res_start`>='$end' AND `res_start`<'$chkafter' AND `status`>'0' LIMIT 0,".$c);
	if($datapdo->numRows($find_res_after)>0){
		while($getafter = $datapdo->fetchRow($find_res_after)){
			$after = $getafter['res_start'];
			$chkC += $getafter['contingent'];
			if($chkC < $c){
				$chk_after = date("d.m.Y",($after+86400));
				$resultafter = $admin->check_res_date($chk_after,$o,2);
				if($resultafter==0){ return $after; }
			}
			else{ $returndate = $after; break; }
		}
	}
	return $returndate;
}
function get_season_price($o,$day,$stp='p0',$is_seas = false){
	global $datapdo;
	$init_year = gmdate('Y',$day);
	$day_of_year = gmdate('z',$day)+1;
	$ret_price = array('',0);
//	if(gmdate('L',$day)==1 AND $day_of_year > 59){ $day_of_year--; }
	// Get default price for this day
	$def_pr = $datapdo->get_one("SELECT `".$stp."` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$o' AND `season_start`='0' AND `season_end`='0' AND `season_name`='SEASON_A' LIMIT 1");
	$ret_price = array('SEASON_A',$def_pr);
	// Check the season price for this day if it is available
	if($is_seas == true){
		$get_seas_p = $datapdo->query("SELECT `season_name`,`".$stp."` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$o' AND `season_start`<='$day_of_year' AND `season_end`>='$day_of_year' AND `season_year`='$init_year' LIMIT 0,1");
		if($datapdo->numRows($get_seas_p)>0){
			$seas_p = $datapdo->fetchRow($get_seas_p);
			$ret_price = array($seas_p['season_name'],$seas_p[$stp]);
		}
		else{
			// if we looking for all years set day of year correktly
			if(gmdate('L',$day)==1 AND $day_of_year > 59){ $day_of_year -=1; }
			$get_seas_p = $datapdo->query("SELECT `season_name`,`".$stp."` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$o' AND `season_start`<='$day_of_year' AND `season_end`>='$day_of_year' AND `season_year`='0' LIMIT 0,1");
			if($datapdo->numRows($get_seas_p)>0){
				$seas_p = $datapdo->fetchRow($get_seas_p);
				$ret_price = array($seas_p['season_name'],$seas_p[$stp]);
			}
		}
	}
	return $ret_price;
}
function get_fixed_price($a,$d,$o,$p,$c){
	global $datapdo;
	$ret_fp = array('fp'=>0,'fp_id'=>0,'inc_adds'=>'','inc_more'=>'');
	$chk_lm_module = $datapdo->query("SELECT `addon_id` FROM `".TABLE_PREFIX."addons` WHERE `directory`='special_offer' LIMIT 0,1");
	if($datapdo->numRows($chk_lm_module)>0){
		$get_ref_obj = $datapdo->query("SELECT `object_id`,`time_from`,`time_to` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$o' LIMIT 1");
		$ref_obj = $datapdo->fetchRow($get_ref_obj);
		$ref_o = $ref_obj['object_id'];
		$time_split = explode(':',$ref_obj['time_from']);
		$h_timeS = (int)$time_split[0];
		$m_timeS = (isset($time_split[1])?(int)$time_split[1]:0);
		$time_split = explode(':',$ref_obj['time_to']);
		$h_timeE = (int)$time_split[0];
		$m_timeE = (isset($time_split[1])?(int)$time_split[1]:0);
		$arrival = gmmktime($h_timeS,$m_timeS,'0',date('n',$a),date('j',$a),date('Y',$a));
		$departure =  gmmktime($h_timeE,$m_timeE,'0',date('n',$d),date('j',$d),date('Y',$d));
		$query_special = "SELECT `lmitem_id`,`price`,`inc_adds`,`inc_more` FROM `".TABLE_PREFIX."res_special` WHERE `ref_object`='$ref_o' AND (`persons`-`children`)>='$p' AND `children`>='$c' AND `date_from`='$arrival' AND `date_to`='$departure' AND `active`='1' LIMIT 0,1";
		$find_special = $datapdo->query($query_special);
		if($datapdo->numRows($find_special)>0){
			$special = $datapdo->fetchRow($find_special);
			$ret_fp['fp'] = $special['price'];
			$ret_fp['fp_id'] = $special['lmitem_id'];
			$ret_fp['inc_adds'] = $special['inc_adds'];
			$ret_fp['inc_more'] = $special['inc_more'];
		}
	}
	return $ret_fp;
}
function get_special_infos($id,$sid,$l=''){
	global $datapdo;
	$inc_name = '';
	$qery_sp_info = "SELECT `item_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$id' AND `fix`='1' AND `single_price`='0' AND (`item_id` LIKE '%ADDS%' OR `item_id` LIKE '%MORE%') ORDER BY `item_id`";
	$get_sp_info = $datapdo->query($qery_sp_info);
	if($datapdo->numRows($get_sp_info)>0){
		while($sp_info = $datapdo->fetchRow($get_sp_info)){
			$type_arr = explode('_',$sp_info['item_id']);
			$type = strtolower($type_arr[0]);
			$val = $type_arr[1];
			$get_n = get_name_addkey($val,$type,$sid,$l);
			if(trim($get_n)!=''){ $inc_name .= (empty($inc_name)?'[INCLUSIVE]':',').' '.$get_n; }
		}
	}
	return $inc_name;
}
function get_name_addkey($k,$t,$o,$l=''){
	global $datapdo;
//	if($k==''){ return ''; }
	if(empty($l)){ $l = LANGUAGE; }
	$retname = '';
	switch ($t){
		case 'adds':
			$get_an = $datapdo->query("SELECT `adds_name`,`external`,`addsstart`,`addsend` FROM `".TABLE_PREFIX."res_price_adds` WHERE `rpadds_id`='$k' LIMIT 0,1");
			if($datapdo->numRows($get_an)>0){
				$inan = $datapdo->fetchRow($get_an);
				$an = $inan['adds_name'];
				$asd = $inan['addsstart'];
				$aed = $inan['addsend'];
				$nn = unserialize($an);
				$isextern = $inan['external'];
				$retname = (isset($nn[$l])?$nn[$l]:$an).($isextern==1?'*':'').(($asd > 0 AND $aed > 0)?' ('.date(DATE_FORMAT,$asd).'-'.date(DATE_FORMAT,$aed).')':'');//$nn[DEFAULT_LANGUAGE]);
			}
			break;
		case 'more':
			$get_frm = $datapdo->query("SELECT `object_id`,`form_object` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$o' LIMIT 1");
			$chk_frm = $datapdo->fetchRow($get_frm);
			if($chk_frm['form_object']==0 OR $chk_frm['form_object']==$chk_frm['object_id']){ $fo = $chk_frm['object_id']; }
			else{ $fo = $chk_frm['form_object']; }
			$tabs = "`".TABLE_PREFIX."form_labels` AS l,`".TABLE_PREFIX."forms` AS f,`".TABLE_PREFIX."res_price_more` AS a";
			$wheresql = "a.`section_id`='".$o."' AND a.`rpmore_id`='".$k."' AND f.`object_id`='$fo' AND f.`field_id`=a.`more_key` AND l.`field_id`=f.`field_id` AND l.`language`='".$l."'";
			$query_names = "SELECT l.`field_label`,l.`field_extra`,a.`more_id`,a.`external` FROM ".$tabs." WHERE ".$wheresql." LIMIT 0,1";
			$get_names = $datapdo->query($query_names);
			if($datapdo->numRows($get_names)>0){
				$names = $datapdo->fetchRow($get_names);
				$isextern = $names['external'];
				$kn = $names['more_id'];
				$an = explode('|',$names['field_extra']);
				$outname = $an[$kn];
				if(is_numeric($outname)){ $outname = $an[$kn].' '.$names['field_label']; }
				$retname = preg_replace('/\+/','',$outname).($isextern==1?'*':'');
			}
			break;
	}
	return $retname;
}
function get_ffld_name($r,$id){
	global $datapdo;
	$returnstr = '';
	$get_label = $datapdo->query("SELECT `label` FROM `".TABLE_PREFIX."res_text_fflds` WHERE `res_id`='$r' AND `item_id`='$id' LIMIT 0,1");
	if($datapdo->numRows($get_label)>0){
		$label = $datapdo->fetchRow($get_label);
		$returnstr = $label['label'];
	}
	return $returnstr;
}
function get_adds_prices($o,$days=1,$nights=true,$pers=1,$ocpers=0,$oc2pers=0,$epers=0,$tab = 'res_price_adds',$m_opt = array()){
	global $datapdo;
	$get_inctoddler = $datapdo->get_one("SELECT `inc_toddler` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$o' LIMIT 1");
	$contpers = ($get_inctoddler==1?$pers:($pers-$oc2pers));
	$cont = get_contingents($o,$contpers);
	$date_sql = '';
	$ret_array = NULL;
	if($cont == 0){ $cont = 1; }
	if($tab == 'res_price_adds'){
		$fields = "`rpadds_id`,`adds_type`,`only_ext_persons`,`adds_price`,`adds_alldays`,`external`";
		$id_field = 'rpadds_id';
		$fld_ini = 'adds';
		$date_sql = " AND `isold`='0' AND `addsstart`='0' AND `addsend`='0'";
	}
	else{
		$fields = "`rpmore_id`,`more_id`,`more_key`,`more_type`,`more_price`,`more_alldays`,`external`";
		$id_field = 'rpmore_id';
		$fld_ini = 'more';
		$date_sql = " AND `isold`='0'";
	}
	// Get first prices for no date settings
	$fulltab = TABLE_PREFIX.$tab;
	$query_all_adds = "SELECT $fields FROM `".$fulltab."` WHERE `section_id`='$o'".$date_sql;
	$get_all_adds = $datapdo->query($query_all_adds);
	if($datapdo->numRows($get_all_adds)>0){
		$ret_array = array();
		while($all_adds = $datapdo->fetchRow($get_all_adds)){
			$id = $all_adds[$id_field];
			$at = $all_adds[$fld_ini.'_type'];
			$ap = $all_adds[$fld_ini.'_price'];
			$extern = $all_adds['external'];
			$plusday = 0;
			if($all_adds[$fld_ini.'_alldays'] == 1 AND $nights == true){ $plusday = 1; }
			if($all_adds[$fld_ini.'_alldays'] == 0 AND $nights == false){ $plusday = -1; }
			if($fld_ini == 'more' AND (!is_numeric(array_search($id,$m_opt)) OR $ap == 0)){ continue 1; }
			if(isset($all_adds['only_ext_persons']) AND $all_adds['only_ext_persons'] > 0){ $cpers = $epers; }
			else{ $cpers = $pers; }
			switch ($at){
				case '12':
					$ret_array[$id][0] = ($days + $plusday) * ($cpers - $oc2pers);
					break;
				case '11':
					$ret_array[$id][0] = ($cpers - $oc2pers);
					break;
				case '10':
					$ret_array[$id][0] = ($cpers - $ocpers - $oc2pers);
					break;
				case '9':
					$ret_array[$id][0] = ($days + $plusday) * $oc2pers;
					break;
				case '8':
					$ret_array[$id][0] = $oc2pers;
					break;
				case '7':
					$ret_array[$id][0] = $ocpers;
					break;
				case '6':
					$ret_array[$id][0] = ($days + $plusday) * $ocpers;
					break;
				case '5':
					$ret_array[$id][0] = ($days + $plusday) * ($cpers - $ocpers - $oc2pers);
					break;
				case '4':
					$ret_array[$id][0] = ($days + $plusday) * $cpers;
					break;
				case '3':
					$ret_array[$id][0] = $cont * ($days + $plusday);
					break;
				case '2':
					$ret_array[$id][0] = $cpers;
					break;
				case '1':
					$ret_array[$id][0] = $cont;
					if(isset($all_adds['only_ext_persons']) AND $all_adds['only_ext_persons'] > 0){
						$extcont = get_extcontingents($o,$contpers,$cont);
						$ret_array[$id][0] = $extcont;
					}
					break;
				case '0':
				default:
//					if(isset($all_adds['only_ext_persons'])){
//						if($all_adds['only_ext_persons'] == 0 OR ($all_adds['only_ext_persons'] > 0 AND $epers > 0)){
							$ret_array[$id][0] = 1;
//						}
//					}
					break;
			}
			$ret_array[$id][0] = ($ret_array[$id][0]<0?0:$ret_array[$id][0]);
			$ret_array[$id][1] = $ap;
			$ret_array[$id][2] = $at;
			$ret_array[$id][3] = $extern;
		}
	}
	if($tab == 'res_price_adds' AND count($m_opt)>0){
		foreach($m_opt AS $aid => $days){
			$query_adds = "SELECT $fields FROM `".TABLE_PREFIX.$tab."` WHERE `section_id`='$o' AND `rpadds_id`='$aid' LIMIT 1";
			$get_adds = $datapdo->query("SELECT $fields FROM `".TABLE_PREFIX.$tab."` WHERE `section_id`='$o' AND `rpadds_id`='$aid' LIMIT 1");
			$adds = $datapdo->fetchRow($get_adds);
			$id = $adds[$id_field];
			$at = $adds[$fld_ini.'_type'];
			$ap = $adds[$fld_ini.'_price'];
			$extern = $adds['external'];
			$plusday = 0;
			if($adds[$fld_ini.'_alldays'] == 1 AND $nights == true){ $plusday = 1; }
			if($adds[$fld_ini.'_alldays'] == 0 AND $nights == false){ $plusday = -1; }
			if(isset($adds['only_ext_persons']) AND $adds['only_ext_persons'] > 0){ $cpers = $epers; }
			else{ $cpers = $pers; }
			switch ($at){
				case '12':
					$ret_array[$id][0] = ($days + $plusday) * ($cpers - $oc2pers);
					break;
				case '11':
					$ret_array[$id][0] = ($cpers - $oc2pers);
					break;
				case '10':
					$ret_array[$id][0] = ($cpers - $ocpers - $oc2pers);
					break;
				case '9':
					$ret_array[$id][0] = ($days + $plusday) * $oc2pers;
					break;
				case '8':
					$ret_array[$id][0] = $oc2pers;
					break;
				case '7':
					$ret_array[$id][0] = $ocpers;
					break;
				case '6':
					$ret_array[$id][0] = ($days + $plusday) * $ocpers;
					break;
				case '5':
					$ret_array[$id][0] = ($days + $plusday) * ($cpers - $ocpers - $oc2pers);
					break;
				case '4':
					$ret_array[$id][0] = ($days + $plusday) * $cpers;
					break;
				case '3':
					$ret_array[$id][0] = $cont * ($days + $plusday);
					break;
				case '2':
					$ret_array[$id][0] = $cpers;
					break;
				case '1':
					$ret_array[$id][0] = $cont;
					if($all_adds['only_ext_persons'] > 0){
						$extcont = get_extcontingents($o,$contpers,$cont);
						$ret_array[$id][0] = $extcont;
					}
					break;
				case '0':
				default:
					if((isset($all_adds['only_ext_persons']) AND $adds['only_ext_persons'] == 0) OR (isset($all_adds['only_ext_persons']) AND $adds['only_ext_persons'] > 0 AND $epers >0)){
						$ret_array[$id][0] = 1;
					}
					break;
			}
			$ret_array[$id][0] = ($ret_array[$id][0]<0?0:$ret_array[$id][0]);
			$ret_array[$id][1] = $ap;
			$ret_array[$id][2] = $at;
			$ret_array[$id][3] = $extern;
		}
	}
	return $ret_array;
}
function get_adds2_prices($o,$date_start=0,$date_end=0,$nights=true,$pers=1,$ocpers=0,$oc2pers=0,$epers=0){
	global $datapdo;
	$get_inctoddler = $datapdo->get_one("SELECT `inc_toddler` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$o' LIMIT 1");
	$contpers = ($get_inctoddler==1?$pers:($pers-$oc2pers));
	$ret_array = NULL;
	$temp_array = array();
	$temp_name = array();
	if($date_start > 0 AND $date_end > $date_start){
		$cont = get_contingents($o,$contpers);
		if($cont == 0){ $cont = 1; }
		$c = $date_start+86400;
		while($c<($date_end+86400)){
			$get_all_adds = $datapdo->query("SELECT `rpadds_id`,`addsstart`,`addsend`,`adds_alldays`,`adds_name` FROM `".TABLE_PREFIX."res_price_adds` WHERE `section_id`='$o' AND `isold`='0' AND `addsstart`>'0' AND `addsend`>'0' AND `isold`='0' ORDER BY `adds_name`,`addsstart` ASC");
			if($datapdo->numRows($get_all_adds)>0){
				while($all_adds = $datapdo->fetchRow($get_all_adds)){
					$adds_names = unserialize($all_adds['adds_name']);
					$adds_name = $adds_names[DEFAULT_LANGUAGE];
					$rpid = $all_adds['rpadds_id'];
					$plusday = $all_adds['adds_alldays'];
					$adate_start = $all_adds['addsstart'];
					$adate_end = $all_adds['addsend'];
					if($c>$adate_start AND $c<=$adate_end){
						if(isset($temp_array[$rpid])){ // AND $c>$adate_start AND $c<$adate_end){
							$temp_array[$rpid]=$temp_array[$rpid]+1;
						}
						else{
							$firsday=0;
							if($plusday==0){ $firsday=1; }
							//if($plusday==0){ $plusday++; }
							if(is_numeric(array_search($adds_name,$temp_name))){ $plusday=0; }
							else{ $temp_name[] = $adds_name; }
							$temp_array[$rpid]=$firsday+$plusday;
						}
					}
				}
			}
			$c = $c+86400;
		}
		$ret_array = $temp_array;
	}
	return $ret_array;
}
function get_holi_prices($o,$day,$pers=1){
	global $datapdo;
	$ret_price = 0;
	$cont = get_contingents($o,$pers);
	$init_year = gmdate('Y',$day);
	$day_of_year = gmdate('z',$day)+1;
	if(gmdate('L',$day)==1 AND $day_of_year > 59){ $day_of_year--; }
	// Check first it is a holiday like date etc. and return this price
	$get_holi_price = $datapdo->query("SELECT `holi_type`,`holi_price` FROM `".TABLE_PREFIX."res_price_holi` WHERE `section_id`='$o' AND `holi_day`='$day_of_year' LIMIT 1");
	if($datapdo->numRows($get_holi_price)>0){
			$holiday_p = $datapdo->fetchRow($get_holi_price);
			if($holiday_p['holi_type']==2){ $m = $pers; }
			if($holiday_p['holi_type']==1){ $m = $cont; }
			else{ $m =1; }
			$ret_price = $holiday_p['holi_price'];
			$ret_type = $holiday_p['holi_type'];
			$ret_name = $day_of_year;
	}
	else{
		$day_of_year = gmdate('z',$day);
		if($day_of_year < 250){
			$easter = easter_days($init_year)+gmdate('z',mktime(12,0,0,3,21,$init_year));
			$holidays_array = array(-48,-47,-46,-3,-2,-1,0,1,39,49,50,60);
			$offset = 400;
		}
		else{
			// get day for bb
			$easter = get_day_of_lastadv($init_year);
			$holidays_array = array(-32,-21,-14,-7,0);
			$offset = 500;
		}
		for($ftd = 0; $ftd < count($holidays_array); $ftd++){
			$tempday = $easter+$holidays_array[$ftd];
			if($day_of_year != $tempday){ continue; }
			$checkday = $offset + $ftd;
			$get_holiday_p = $datapdo->query("SELECT `holi_type`,`holi_price` FROM `".TABLE_PREFIX."res_price_holi` WHERE `section_id`='$o' AND `holi_day`='$checkday' LIMIT 1");
			if($datapdo->numRows($get_holiday_p)>0){
				$holiday_p = $datapdo->fetchRow($get_holiday_p);
				if($holiday_p['holi_type']==2){ $m = $pers; }
				elseif($holiday_p['holi_type']==1){ $m = $cont; }
				else{ $m =1; }
				$ret_price = $holiday_p['holi_price'];
				$ret_type = $holiday_p['holi_type'];
				$ret_name = $checkday;
			}
		}
	}
	// If we have a price return this
	if($ret_price > 0 ){ return array($ret_name,$m,$ret_price,$ret_type,$init_year); }
	else return NULL;
}

function get_holi_show($o,$day){
	global $datapdo;
	$owner = $datapdo->get_one("SELECT `owner` FROM `".TABLE_PREFIX."objects` WHERE `object_id`='$o' LIMIT 1");
	$init_year = gmdate('Y',$day);
	$day_of_year = gmdate('z',$day)+1;
	$ret_name = 0;
	if(gmdate('L',$day)==1 AND $day_of_year > 59){ $day_of_year--; }
	// Check first it is a holiday like date etc. and return this price
	$get_holishow = $datapdo->query("SELECT `holidays_id` FROM `".TABLE_PREFIX."holidays` WHERE `user_id`='$owner' AND `holi_day`='$day_of_year' AND `show`='1' LIMIT 0,1");
	if($datapdo->numRows($get_holi_price)>0){
			$holishow = $datapdo->fetchRow($get_holishow);
			$ret_name = $day_of_year;
	}
	else{
		$day_of_year = gmdate('z',$day);
		if($day_of_year < 250){
			$easter = easter_days($init_year)+gmdate('z',mktime(12,0,0,3,21,$init_year));
			$holidays_array = array(-48,-47,-46,-3,-2,-1,0,1,39,49,50,60);
			$offset = 400;
		}
		else{
			// get day for bb
			$easter = get_day_of_lastadv($init_year);
			$holidays_array = array(-32,-21,-14,-7,0);
			$offset = 500;
		}
		for($ftd = 0; $ftd < count($holidays_array); $ftd++){
			$tempday = $easter+$holidays_array[$ftd];
			if($day_of_year != $tempday){ continue; }
			$checkday = $offset + $ftd;
			$get_holishow = $datapdo->query("SELECT `show` FROM `".TABLE_PREFIX."holidays` WHERE `user_id`='$owner' AND `holi_day`='$checkday' AND `show`='1' LIMIT 0,1");
			if($datapdo->numRows($get_holishow)>0){
				$holishow = $datapdo->fetchRow($get_holishow);
				$ret_name = $checkday;
			}
		}
	}
	return $ret_name;
}

function get_day_of_lastadv($y){
	$lastadv = gmdate('z',mktime(12,0,0,12,24,$y)) - gmdate('w',mktime(12,0,0,12,24,$y));
	return $lastadv;
}
function get_discounts($o,$p,$d,$a){
	global $datapdo;
	$ret_array = array();
	$price_set = get_iprice_settings($o);
	// Get the dicounts for zhis object
	$get_objdisc = $datapdo->query("SELECT `object_id`,`discount_type`,`lastminute_days`,`percent` FROM `".TABLE_PREFIX."res_discounts` WHERE `section_id`='$o'");
	if($datapdo->numRows($get_objdisc)>0){
		while($objdisc = $datapdo->fetchRow($get_objdisc)){
			$oi = $objdisc['object_id'];
			$dt = $objdisc['discount_type'];
			$ld = $objdisc['lastminute_days'];
			$pc = $objdisc['percent'];
			$m = $pc / 100;
			if($m == 0 OR $dt == 0 OR $dt == 4 OR ($dt == 1 AND $a == 0)){ continue; }
			if($dt > 1 AND $ld > 0){
				$chk_ld = ceil(($d - time()) / 86400);
				if(($dt == 2 AND $chk_ld <= $ld) OR ($dt == 3 AND $chk_ld >= $ld)){
					$minus_ptmp = $p * $m;
					$minus_p = round($minus_ptmp,2);
if($price_set['roundprice']==1){ $minus_p = round(($minus_ptmp * 2),1)/2; }
					$ret_array[$dt] = array($pc,$minus_p);
				}
			}
			else{
				if(check_old_customer($oi,$a) > 0){
					$minus_ptmp = $p * $m;
					$minus_p = round($minus_ptmp,2);
if($price_set['roundprice']==1){ $minus_p = round(($minus_ptmp * 2),1)/2; }
					$ret_array[$dt] = array($pc,$minus_p);
				}
			}
		}
	}
	return $ret_array;
}
function check_old_customer($o,$id){
	global $datapdo;
	$ret_id = 0;
	$owner = $datapdo->get_one("SELECT `owner` FROM `".TABLE_PREFIX."objects` WHERE `object_id`='$o' LIMIT 1");
	// Get the old reservations this address
	$get_customer = $datapdo->query("SELECT `customer_id` FROM `".TABLE_PREFIX."res_customers` WHERE `owner`='$owner' AND `adr_id`='$id' LIMIT 0,1");
	if($datapdo->numRows($get_customer) > 0){
		$ret_id = $id;
	}
	return $ret_id;
}
function insert_prices($tp,$o,$s,$r,$a){
	global $datapdo;
	$retur = true;
	$pre_price = $tp['pre_price'];
	$total_price = $tp['total_price'];
	$fixed_price = $tp['fixed_price'];
	$package = $tp['package'];
	$fix = ($fixed_price > 0?'1':'0');
	$pre_price = $tp['pre_price'];
	$res_days = $tp['res_days'];
	$db_insert = ("INSERT INTO `".TABLE_PREFIX."res_price_calc` "
		      ."(`object_id`,`section_id`,`res_id`,`res_days`,`adr_id`,`total_price`,`fixed_price`,`package`,`pre_price`,`storno_price`,`paid_price`) VALUES "
		      ."('$o','$s','$r','$res_days','$a','$total_price','$fixed_price','$package','$pre_price','0','0')");
	$datapdo->query($db_insert);
	if($datapdo->is_error()){
		$retur = false;
	}
	else{
		// Get vat-ids like price calculator
		$def_vat_id = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_price_seas` WHERE `object_id`='$o' LIMIT 1");
		$get_add = $tp['adds_price'];
		$get_add_fix = $tp['adds_price_fix'];
		$get_more = $tp['more_price'];
		$get_more_fix = $tp['more_price_fix'];
		$sql = '';
		if(count($get_add)>0){
			foreach($get_add AS $item => $value){
				$sql .= ($sql != ''?" OR ":"(")."`rpadds_id`='".$item."'";
			}
			$sql .= ")";
			$get_vats_a = $datapdo->query("SELECT `rpadds_id`,`vat` FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$o' AND `isold`='0' AND ".$sql);
			while($vats = $datapdo->fetchRow($get_vats_a)){
				$tp['adds_price'][$vats['rpadds_id']][4] = $vats['vat'];
			}
		}
		$sql = '';
		if(count($get_add_fix)>0){
			foreach($get_add_fix AS $item => $value){
				$sql .= ($sql != ''?" OR ":"(")."`rpadds_id`='".$item."'";
			}
			$sql .= ")";
			$get_vats_af = $datapdo->query("SELECT `rpadds_id`,`vat` FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$o' AND `isold`='0' AND ".$sql);
			while($vats = $datapdo->fetchRow($get_vats_af)){
				$tp['adds_price_fix'][$vats['rpadds_id']][4] = $vats['vat'];
			}
		}
		$sql = '';
		if(count($get_more)>0){
			foreach($get_more AS $item => $value){
				$sql .= ($sql != ''?" OR ":"(")."`rpmore_id`='".$item."'";
			}
			$sql .= ")";
			$get_vats_m = $datapdo->query("SELECT `rpmore_id`,`vat` FROM `".TABLE_PREFIX."res_price_more` WHERE `object_id`='$o' AND `isold`='0' AND ".$sql);
			while($vats = $datapdo->fetchRow($get_vats_m)){
				$tp['more_price'][$vats['rpmore_id']][4] = $vats['vat'];
			}
		}
		$sql = '';
		if(count($get_more_fix)>0){
			foreach($get_more_fix AS $item => $value){
				$sql .= ($sql != ''?" OR ":"(")."`rpmore_id`='".$item."'";
			}
			$sql .= ")";
			$get_vats = $datapdo->query("SELECT `rpmore_id`,`vat` FROM `".TABLE_PREFIX."res_price_more` WHERE `object_id`='$o' AND `isold`='0' AND ".$sql);
			while($vats = $datapdo->fetchRow($get_vats)){
				$tp['more_price_fix'][$vats['rpmore_id']][4] = $vats['vat'];
			}
		}
		$book_prices1 = $tp['book_prices1'];
		if(count($book_prices1) > 0){
			foreach($book_prices1 AS $item_id => $v_arr){
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$ppp = $v_arr[2];
				$item_id_text = $item_id.'_1';
				$datapdo->query("INSERT INTO `".TABLE_PREFIX."res_invoice` "
				."(`object_id`,`section_id`,`res_id`,`quantity`,`item_id`,`single_price`,`vat`,`ppp`,`external`) VALUES "
				."('$o','$s','$r','$quantity','$item_id_text','$single_price','$def_vat_id','$ppp','0')");
			}
		}
		$book_prices2 = $tp['book_prices2'];
		if(count($book_prices2) > 0){
			foreach($book_prices2 AS $item_id => $v_arr){
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$ppp = $v_arr[2];
				$item_id_text = $item_id.'_2';
				$datapdo->query("INSERT INTO `".TABLE_PREFIX."res_invoice` "
				  ."(`object_id`,`section_id`,`res_id`,`quantity`,`item_id`,`single_price`,`vat`,`ppp`,`external`) VALUES "
				  ."('$o','$s','$r','$quantity','$item_id_text','$single_price','$def_vat_id','$ppp','0')");
			}
		}
		$book_pricesF = $tp['book_prices_fix'];
		if(count($book_pricesF) > 0){
			foreach($book_pricesF AS $item_id => $v_arr){
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$ppp = $v_arr[2];
				$item_id_text = $item_id;
				$datapdo->query("INSERT INTO `".TABLE_PREFIX."res_invoice` "
				  ."(`object_id`,`section_id`,`res_id`,`quantity`,`item_id`,`single_price`,`vat`,`ppp`,`fix`,`external`) VALUES "
				  ."('$o','$s','$r','$quantity','$item_id_text','$single_price','$def_vat_id','$ppp','1','0')");
			}
		}
		$holi_prices = $tp['holi_price'];
		if(count($holi_prices) > 0){
			foreach($holi_prices AS $item_id => $v_arr){
				$item_id_text = 'HOLI_'.$item_id;
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$ppp = $v_arr[2];
				$datapdo->query("INSERT INTO `".TABLE_PREFIX."res_invoice` "
				  ."(`object_id`,`section_id`,`res_id`,`quantity`,`item_id`,`single_price`,`vat`,`ppp`,`external`) VALUES "
				  ."('$o','$s','$r','$quantity','$item_id_text','$single_price','$def_vat_id','$ppp','0')");
			}
		}
		$more_prices = $tp['more_price'];
		if(count($more_prices) > 0){
			$insert_sql = "INSERT INTO `".TABLE_PREFIX."res_invoice` "
				  ."(`object_id`,`section_id`,`res_id`,`item_id`,`external`,`single_price`,`vat`,`quantity`,`fix`,`ppp`) VALUES ";
			foreach($more_prices AS $item_id => $v_arr){
				$item_id_text = 'MORE_'.$item_id;
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$ppp = $v_arr[2];
				$extern = $v_arr[3];
				$more_vat_id = (isset($v_arr[4])?$v_arr[4]:'B');
				$insert_sql .= "('$o','$s','$r','$item_id_text','$extern','$single_price','$more_vat_id','$quantity','0','$ppp'),";
			}
			$insert_sql = substr($insert_sql,0,-1);
			$datapdo->query($insert_sql);
		}
		$more_prices_fix = $tp['more_price_fix'];
		if(count($more_prices_fix) > 0){
			foreach($more_prices_fix AS $item_id => $v_arr){
				$item_id_text = 'MORE_'.$item_id;
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$ppp = $v_arr[2];
				$extern = $v_arr[3];
				$more_vat_id = (isset($v_arr[4])?$v_arr[4]:'B');
				$datapdo->query("INSERT INTO `".TABLE_PREFIX."res_invoice` "
				  ."(`object_id`,`section_id`,`res_id`,`quantity`,`item_id`,`single_price`,`vat`,`ppp`,`fix`,`external`) VALUES "
				  ."('$o','$s','$r','$quantity','$item_id_text','$single_price','$more_vat_id','$ppp','1','$extern')");
			}
		}
		$adds_prices = $tp['adds_price'];
		if(count($adds_prices) > 0){
			foreach($adds_prices AS $item_id => $v_arr){
				$item_id_text = 'ADDS_'.$item_id;
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$ppp = $v_arr[2];
				$extern = $v_arr[3];
				$adds_vat_id = (isset($v_arr[4])?$v_arr[4]:'B');
				$datapdo->query("INSERT INTO `".TABLE_PREFIX."res_invoice` "
				  ."(`object_id`,`section_id`,`res_id`,`quantity`,`item_id`,`single_price`,`vat`,`ppp`,`fix`,`external`) VALUES "
				  ."('$o','$s','$r','$quantity','$item_id_text','$single_price','$adds_vat_id','$ppp','0','$extern')");
			}
		}
		$adds_prices_fix = $tp['adds_price_fix'];
		if(count($adds_prices_fix) > 0){
			foreach($adds_prices_fix AS $item_id => $v_arr){
				$item_id_text = 'ADDS_'.$item_id;
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$ppp = $v_arr[2];
				$extern = $v_arr[3];
				$adds_vat_id = (isset($v_arr[4])?$v_arr[4]:'B');
				$datapdo->query("INSERT INTO `".TABLE_PREFIX."res_invoice` "
				  ."(`object_id`,`section_id`,`res_id`,`quantity`,`item_id`,`single_price`,`vat`,`ppp`,`fix`,`external`) VALUES "
				  ."('$o','$s','$r','$quantity','$item_id_text','$single_price','$adds_vat_id','$ppp','1','$extern')");
			}
		}
		$discounts = $tp['discounts'];
		if(count($discounts) > 0){
			foreach($discounts AS $item_id => $v_arr){
				$item_id_text = 'DISC_'.$item_id;
				$quantity = $v_arr[0];
				$single_price = round($v_arr[1],2,PHP_ROUND_HALF_DOWN);
				$datapdo->query("INSERT INTO `".TABLE_PREFIX."res_invoice` "
				  ."(`object_id`,`section_id`,`res_id`,`quantity`,`item_id`,`single_price`) VALUES "
				  ."('$o','$s','$r','$quantity','$item_id_text','$single_price')");
			}
		}
	}
	return $retur;
}

function build_price_table($tp,$o,$s,$r,$persons,$children,$toddler,$to='form',$multi=false,$lang='',$disable_input='',$reminderstatus=false,$show_netto=false){
	global $datapdo;
	global $TEXT;
	$price_set = get_iprice_settings($s);
	$show_vats = $datapdo->numRows($datapdo->query("SELECT `vat` FROM `".TABLE_PREFIX."res_price_seas` WHERE `object_id`='$o' AND `vat`!='B' LIMIT 0,1"));;
	if($r>0){
		$get_status = $datapdo->get_one("SELECT `status` FROM `".TABLE_PREFIX."reservations` WHERE `res_id`='$r' LIMIT 1");
		$disable_modify = ($get_status == 0?' disabled':'');
		$get_storno_calc = $datapdo->query("SELECT `storno_price`,`res_days`,`storno_days` FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$r' LIMIT 1");
		$get_storno_price = $datapdo->fetchRow($get_storno_calc);
		$storno_price = $get_storno_price['storno_price'];
		$storno_days = $get_storno_price['storno_days'];
	}
	else{
		$get_status = '2';
		$disable_modify = ' disabled';
		$storno_price = 0;
		$storno_days = $tp['res_days'];
	}
	$add_ffld_fix = 0;
	$is_ro = false;

	if(empty($lang)){ $lang = LANGUAGE; }
	$allpersons = $persons + $children + $toddler;
	$incchild2 = $datapdo->get_one("SELECT `inc_toddler` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$o' LIMIT 1");
	if($incchild2 == 0){ $contpersons = $allpersons - $toddler; }
	else{ $contpersons = $allpersons; }
	$contingent = get_contingents($s,$contpersons);
	$persons = ($persons == 0?1:$persons);
	$res_days = $tp['res_days'];
	$date_days = $tp['date_days'];
	$book_prices1 = $tp['book_prices1'];
	$book_prices_fix = $tp['book_prices_fix'];
	if(($to == 'form' OR $to == 'billet') AND count($book_prices1)==0 AND count($book_prices_fix)==0){
		// We heve not prices
		return '';
	}
	if(($to=='billet' OR $to == 'newcalc') AND $show_vats>0){
		// Get current vats
		$vats = array();
		$get_vats = $datapdo->query("SELECT `vat_nameid`,`vat_percent`,`vat_fullname` FROM `".TABLE_PREFIX."billing_vat` WHERE `vat_start`<'".time()."' AND (`vat_end`='0' OR `vat_end`>'".time()."')");
		while($vatsdb = $datapdo->fetchRow()){
			$vat_nameid = substr($vatsdb['vat_nameid'],0,1);
			$vats[$vat_nameid] = array('vat_percent'=>$vatsdb['vat_percent'],'vat_fullname'=>$vatsdb['vat_fullname'],'base_price'=>0,'vat_price'=>0);
		}
	}
	// Include the language
	if(file_exists(BC_PATH.'/languages/'.$lang.'.php')){
		include(BC_PATH.'/languages/'.$lang.'.php');
	}
	else{
		include(BC_PATH.'/languages/EN.php');
	}
	if(file_exists(BC_PATH.'/modules/calendar/languages/'.$lang.'.php')){
		include(BC_PATH.'/modules/calendar/languages/'.$lang.'.php');
	}
	else{
		include(BC_PATH.'/modules/calendar/languages/EN.php');
	}
	if(file_exists(BC_PATH.'/languages/user_'.$lang.'.php')){
		include(BC_PATH.'/languages/user_'.$lang.'.php');
	}
	if(file_exists(BC_PATH.'/modules/calendar/languages/user_'.$lang.'.php')){
		include(BC_PATH.'/modules/calendar/languages/user_'.$lang.'.php');
	}
	if($lang != 'EN'){ $dec_point = ','; $thousends = '.'; }else{ $dec_point = '.'; $thousends = ','; }

	// Get all holiday names like holidays db and set them into CALTEXT
	$get_holies = $datapdo->query("SELECT `holi_day`,`holiname` FROM `".TABLE_PREFIX."holidays` WHERE `language`='$lang'");
	if($datapdo->numRows($get_holies)>0){
		while($holies = $datapdo->fetchRow($get_holies)){
			$CALTEXT['HOLI_'.$holies['holi_day']] = $holies['holiname'];
		}
	}
	$p_unit = (isset($TEXT['PRICE_UNIT'][$tp['p_unit']])?$TEXT['PRICE_UNIT'][$tp['p_unit']]:$tp['p_unit']);
	$total_price = round($tp['total_price'],2);
	$fixed_price = round($tp['fixed_price'],2);
	$paid_price = (isset($tp['paid_price'])?round($tp['paid_price'],2):0);
	$pre_price = round($tp['pre_price'],2);
	if($price_set['roundprice']==1){ $pre_price = round(($pre_price*2),1)/2; }
	$price_withoutdisc = 0;
	$price_external = 0;
	$have_external = false;
	$print_table = '';
	$tabind = 0;
	$objname = $datapdo->get_one("SELECT `object_title` FROM `".TABLE_PREFIX."obj_texts` WHERE `object_id`='$o' AND `language`='$lang' LIMIT 1");
	$showdays = $datapdo->get_one("SELECT `countalldays` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$o' LIMIT 1");
	$ext_persons = $datapdo->get_one("SELECT `ext_persons` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$o' LIMIT 1");
	$max_persons = $datapdo->get_one("SELECT `max_persons` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$o' LIMIT 1");
	$price_type = $datapdo->get_one("SELECT `price_type` FROM `".TABLE_PREFIX."res_price_sets` WHERE `object_id`='$o' LIMIT 1");
	$ext_pers = $allpersons - $max_persons + $ext_persons;
	$sp_persons = $allpersons;
	$tabwidth = ($to=='form'?'80%':'100%');
	$is_package = false;
	$p_base = 0;
	$daynight_txt = ($showdays==1?$TEXT['TERMIN_ANZ']:$TEXT['TERMIN_ANZN']);
	if($fixed_price > 0){
		$book_prices1 = array();
		$is_package = true;
	}
	if(count($book_prices1) > 0 OR count($book_prices_fix) > 0){
		$tdwidth1 = '40%';
		$colspanning = '4';
		if($to=='billet' AND $show_vats > 0){ $tdwidth1 = '30%'; }
		if($show_vats > 0){ $colspanning = '5'; }
		$price_table = '<div style="text-align:left"><table width="'.$tabwidth.'">'.($multi==true?'<tr><th colspan="'.$colspanning.'">'.$objname.'</th></tr>':'').'<tr><td colspan="'.$colspanning.'"><b>'.$CALTEXT['CALCULATOR'].'</b> ('.$date_days.((count($book_prices_fix)==0 AND $date_days<$res_days)?'/'.$res_days:'').' '.$daynight_txt.($persons > 0?' / '.$persons.' '.(($children>0 OR $toddler>0)?$CALTEXT['ADULTS']:$CALTEXT['PERSONS']):'').($children > 0?' / '.$children.' '.$CALTEXT['CHILDREN']:'').($toddler > 0?' / '.$toddler.' '.$CALTEXT['TODDLER']:'').($contingent > 1?' / '.$contingent.' '.$CALTEXT['CONTINGENTS']:'').'):</td></tr>';
		$price_table .= '<tr'.($to=='newcalc'?' class="row_b"':'').'><td width="'.$tdwidth1.'">'.$TEXT['LABEL'].'</td><td width="15%" align="center">'.$CALTEXT['MULTIPLICATOR'].'</td><td width="20%" align="right">'.$CALTEXT['SINGLEPRICE'].'</td><td width="20%" align="right">'.$CALTEXT['TOTALPRICE'].'</td>'.((($to=='billet' OR $to=='newcalc') AND $show_vats > 0)?'<td style="width:10%;text-align:center;">'.$TEXT['VAT_SHORT'].'</td>':'').'</tr>';
		$incl_ids = '';
		if($is_package == true){
			foreach($book_prices_fix AS $item_id => $v_arr){
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$ppp = $v_arr[2];
				$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
				if(!isset($tp['fp_info']) OR empty($tp['fp_info'])){
					//Get the infos from special db
					$info = get_special_infos($r,$s,$lang);
					$info = str_replace('[INCLUSIVE]',$CALTEXT['INCLUSIVE'],$info);
				}
				else{ $info = $tp['fp_info']; }
				$item_id_text = $item_id;
				$inpfld_1a = '';
				$inpfld_1b = '';
				$inpfld_2a = '';
				$inpfld_2b = '';
				$m = $quantity;
				$gp = $m * $single_price;
				if($to == 'newcalc' AND $inv_id > 0){
					$inpfld_1a = '<input'.$disable_modify.' type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
					$tabind++;
					$inpfld_1a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',\''.$m.'\',\''.$inv_id.'\',true);" maxlength="6" style="text-align:right;width:55%" value="';
					$inpfld_1b = '" />';
					$inpfld_2a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
					$tabind++;
					$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
					$inpfld_2b = '" />';
				}
				// Check we have the field toddler in special
				$new_field = true;
				$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_special`");
				while($row = $datapdo->fetchRow($get_fields)){
					if($row[0]=='toddler'){ $new_field = false; }
				}
				if($new_field==true){ $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_special` ADD `toddler` TINYINT(3) NOT NULL"); }
				$sp_persons = $datapdo->get_one("SELECT `persons` FROM `".TABLE_PREFIX."res_special` WHERE `lmitem_id`='$ppp' LIMIT 1");
				$sp_children = $datapdo->get_one("SELECT `children` FROM `".TABLE_PREFIX."res_special` WHERE `lmitem_id`='$ppp' LIMIT 1");
				$sp_toddler = $datapdo->get_one("SELECT `toddler` FROM `".TABLE_PREFIX."res_special` WHERE `lmitem_id`='$ppp' LIMIT 1");
				$sp_adults = $sp_persons - $sp_children - $sp_toddler;
				$print_persons = $sp_adults.' '.(($sp_children>0 OR $sp_toddler>0)?$CALTEXT['ADULTS']:$CALTEXT['PERSONS']).($sp_children>0?' / '.$sp_children.' '.$CALTEXT['CHILDREN']:'').($sp_toddler>0?' / '.$sp_toddler.' '.$CALTEXT['TODDLER']:'');
				$print_quantity = $date_days.' '.($showdays==1?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1)).' / '.$print_persons.(!empty($info)?'<br />'.$info:'');
				$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$CALTEXT['SPECIAL_OFFER'].'</td><td align="center">'.$print_quantity.'</td>';
				$price_table .= '<td align="right">'.$inpfld_1a.number_format($single_price,2,$dec_point,$thousends).$inpfld_1b.' '.$p_unit.'</td>';
				$price_table .= '<td align="right">'.$inpfld_2a.number_format($gp,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
				$is_othervat = false;
				if(($to=='billet' OR $to=='newcalc') AND $show_vats > 0){
					$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
					$vatid_print = $vatid;
					$p_base += $gp;
					// Check vatid for inclusivs are different to special
					$get_othervatids = $datapdo->query("SELECT `item_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `vat`!='$vatid' AND `fix`='1' AND `quantity`>'0' AND `single_price`='0'");
					if($datapdo->numRows($get_othervatids)>0){
						$is_othervat = true;
						while($othervids = $datapdo->fetchRow($get_othervatids)){
							$iid = $othervids['item_id'];
							$get_currvatids = $datapdo->query("SELECT `vat`,`single_price`,`quantity` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$iid' AND `fix`='0' LIMIT 1");
							$currvids = $datapdo->fetchRow($get_currvatids);
							$currvatid = ($currvids['vat']==''?'B':$currvids['vat']);
							$currgp = $currvids['single_price']*$currvids['quantity'];
							$p_base -= $currgp;
							$c_base = $vats[$currvatid]['base_price']+$currgp;
							$vats[$currvatid]['base_price']=$c_base;
							if(!preg_match('='.$currvatid.'=',$vatid_print)){ $vatid_print .= '/'.$currvatid; }
						}
					}
					$vats[$vatid]['base_price']=$p_base;
					$price_table .= '<td align="center">';
					if($to=='newcalc'){
						$price_table .= '<select name="vatid_'.$inv_id.'" onchange="set_newvat_calc_button(\''.$inv_id.'\',\''.$gp.'\',\''.$m.'\',this.value,\''.$vatid.'\',false);">';
						$price_table .= '<option value"'.substr($vatid_print,0,1).'">'.$vatid_print.'</option>';
						foreach($vats AS $vid => $varr){
							if($vid == substr($vatid_print,0,1)){ continue 1; }
							$select = ($vatid==$vid?' selected="selected"':'');
							$price_table .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
						}
						$price_table .= '</select>';
					}
					else{ $price_table .= $vatid_print; }
					$price_table .= '</td>';
					if($is_othervat == true){
						$price_table .= '</tr><tr><td colspan="2">&nbsp;</td><td colspan="3" style="text-align:center;">';
						$price_split = '';
						foreach($vats AS $v_id => $v_arr){
							if($v_arr['base_price']>0){
								$price_split .= (!empty($price_split)?' / ':'').number_format($v_arr['base_price'],2,$dec_point,$thousends).' '.$p_unit.' =&gt; '.$v_id;
							}
						}
						$price_table .= '('.$price_split.')</td>';
					}
				}
				$price_table .= '</tr>';
			}
			// Get all external prices to subtract from output price
			$extmore_prices = array();
			if(count($tp['more_price'])>0){
				$extmore_prices = $tp['more_price'];
			}
			else{
				// get external more prices from invoice
				$getmore_prices = $datapdo->query("SELECT `item_id`,`quantity`,`single_price`,`ppp`,`invoice_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `external`='1' AND `item_id` LIKE 'MORE%'");
				if($datapdo->numRows($getmore_prices)>0){
					while($inmore = $datapdo->fetchRow($getmore_prices)){
						if($inmore['single_price']>0){
							$extmore_prices[$inmore['item_id']] = array($inmore['quantity'],$inmore['single_price'],$inmore['ppp'],1,$inmore['invoice_id']);
						}
					}
				}
			}
			foreach($extmore_prices AS $item_id => $v_arr){
				if(isset($v_arr[3]) AND $v_arr[3]==1){
					$price_external = $price_external + ($v_arr[0] * $v_arr[1]);
					$have_extarnal = true;
				}
			}
			$extadds_prices = array();
			if(count($tp['adds_price'])>0){
				$extadds_prices = $tp['adds_price'];
			}
			else{
				// get external more prices from invoice
				$queryadds_prices = "SELECT `item_id`,`quantity`,`single_price`,`ppp`,`invoice_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `external`='1' AND `item_id` LIKE 'ADDS%'";
				$getadds_prices = $datapdo->query($queryadds_prices);
				if($datapdo->numRows($getadds_prices)>0){
					while($inadds = $datapdo->fetchRow($getadds_prices)){
						if($inadds['single_price']>0){
							$extadds_prices[$inadds['item_id']] = array($inadds['quantity'],$inadds['single_price'],$inadds['ppp'],1,$inadds['invoice_id']);
						}
					}
				}
			}
			foreach($extadds_prices AS $item_id => $v_arr){
				if(isset($v_arr[3]) AND $v_arr[3]==1){
					$price_external = $price_external + ($v_arr[0] * $v_arr[1]);
					$have_extarnal = true;
				}
			}
			$more_prices = $tp['more_price_fix'];
			$price_morehead = '';
			$olditem_id = 0;
			if(count($more_prices) > 0){
				$price_morehead = '<tr'.($to=='newcalc'?' class="row_b"':'').'><td colspan="'.$colspanning.'">'.$CALTEXT['ADDS_INFO'].' - '.$CALTEXT['ADDS_MORE'].':</td></tr>';
				$price_tabmore = '';
				foreach($more_prices AS $item_id => $v_arr){
					$quantity = $v_arr[0];
					$single_price = $v_arr[1];
					$ppp = $v_arr[2];
					$external = (isset($v_arr[3])?$v_arr[3]:0);
					$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
					$m = $quantity;
					$gp = $m * $single_price;
					if($m > 0){
						if($to == 'newcalc' OR $single_price > 0){
							$more_plus = $datapdo->get_one("SELECT `more_alldays` FROM `".TABLE_PREFIX."res_price_more` WHERE `section_id`='$s' AND `rpmore_id`='$item_id' LIMIT 1");
							$adds_ext = 0; //$datapdo->get_one("SELECT `only_ext_persons` FROM `".TABLE_PREFIX."res_price_more` WHERE `section_id`='$s' AND `rpmore_id`='$item_id' LIMIT 1");
							$more_fld = $datapdo->get_one("SELECT `more_key` FROM `".TABLE_PREFIX."res_price_more` WHERE `section_id`='$s' AND `rpmore_id`='$item_id' LIMIT 1");
							$print_anz = ($more_plus > 0?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1));
							$item_id_text = 'MORE_'.$item_id;
//							$inv_id = (isset($v_arr[3])?$v_arr[3]:0);
//							$type = (isset($v_arr[2])?$v_arr[2]:0);
							$adults = $allpersons - $children - $toddler;
							$more_name = get_name_addkey($item_id,'more',$s,$lang);

							if(empty($more_name) AND $to=='newcalc'){
								$get_currmores = $datapdo->query("SELECT `rpmore_id` FROM `".TABLE_PREFIX."res_price_more` WHERE `object_id`='$o' AND `isold`='0'");
								if($datapdo->numRows($get_currmores)>0){
									$more_name = '<select name="newadd'.$item_id.'" onchange="set_newadd(\''.$r.'\',\'more\','.$item_id.',this.value);" style="width:80%;">'."\n";
									$more_name .= '<option value="0">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</option>'."\n";
									while($currmores = $datapdo->fetchRow($get_currmores)){
										$more_name .= '<option value="'.$currmores['rpmore_id'].'">'.get_name_addkey($currmores['rpmore_id'],'more',$s,$lang).'</option>'."\n";
									}
									$more_name .= '</select>'."\n";
									$more_fld = 0;
									$more_plus = 0;
									$more_external = 0;
								}
								else{
									$more_fld = 0;
									$more_plus = 0;
									$more_external = 0;
									$more_name = '<span style="color:red;">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</span>';
								}
							}

							// Check the more field is radio or option
							$chk_field = $datapdo->get_one("SELECT `field_typ` FROM `".TABLE_PREFIX."forms` WHERE `field_id`='$more_fld' LIMIT 1");
							if($chk_field == 'RADIO' OR $chk_field == 'OPTION'){ $is_ro = true; }
							switch ($ppp){
								case 12:
									$pers_ae = $allpersons-$toddler;
									$div_pers = ($ext_pers < $pers_ae?$ext_pers:$pers_ae);
									$print_temp0 = $CALTEXT['PERSONS'];
									$print_temp1 = $CALTEXT['ADULTS'];
									$print_temp2 = $CALTEXT['CHILDREN'];
									$print_pers = $div_pers;
									$print_persons = (($children==0 OR $adults==0)?mb_substr($print_temp0,0,1):mb_substr($print_temp1,0,3).'+'.mb_substr($print_temp2,0,2));
									$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
									if($print_quantity>0){
										$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
										$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
									}
									break;
								case 11:
									$quant_adults = $quantity-$toddler;
									if($quant_adults == $quantity OR $children == $quantity){
										$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['PERSONS'],0,1));
									}
									else{
										$print_quantity = $quant_adults.($is_ro == true?'':' '.mb_substr($CALTEXT['ADULTS'],0,3).'+'.$children.' '.mb_substr($CALTEXT['CHILDREN'],0,2));
									}
									break;
								case 10:
									$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['ADULTS'],0,3));
									break;
								case 9:
									$print_temp = $CALTEXT['TODDLER'];
									$print_pers = $toddler;
									$print_persons = mb_substr($print_temp,0,2);
									$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
									if($print_quantity>0){
										$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
										$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
									}
									break;
								case 8:
									$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['TODDLER'],0,2));
									break;
								case 7:
									$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['CHILDREN'],0,2));
									break;
								case 6:
									$div_pers = (($adds_ext > 0 AND $ext_pers < $children)?$ext_pers:$children);
									$print_temp = $CALTEXT['CHILDREN'];
									$print_pers = $div_pers;
									$print_persons = mb_substr($print_temp,0,2);
									$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
									if($print_quantity>0){
										$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
										$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
									}
									break;
								case 5:
									$div_pers = (($adds_ext > 0 AND $ext_pers < $adults)?$ext_pers:$adults);
									$print_pers = $div_pers;
									$print_temp = (($children>0 OR $toddler>0)?$CALTEXT['ADULTS']:$CALTEXT['PERSONS']);
									$chars = (($children>0 OR $toddler>0)?3:1);
									$print_persons = mb_substr($print_temp,0,$chars);
									$print_quantity = ($print_pers>0?($quantity / $print_pers):$allpersons);
									$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
									$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
									break;
								case 4:
									$div_pers = (($adds_ext > 0 AND $ext_pers > 0)?$ext_pers:$allpersons);
									$print_temp = $CALTEXT['PERSONS'];
									$print_pers = $div_pers;
									$print_persons = mb_substr($print_temp,0,1);
									$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
									$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
									$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
									break;
								case 3:
									$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==($date_days + $more_plus)) ? ($date_days + $more_plus).' '.$print_anz.' * '.$contingent.' '.mb_substr($CALTEXT['CONTINGENTS'],0,1):$quantity).(($quantity > 1 AND $contingent == 1)?' '.$print_anz:'');
									break;
								case 2:
									$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['PERSONS'],0,1));
									break;
								case 1:
									$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['CONTINGENTS'],0,1));
									break;
								case 0:
								default:
									$print_quantity = $quantity;
//									$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==($date_days + $adds_plus)) ? ($date_days + $adds_plus).' '.$print_anz.' * '.$contingent.' '.$printtext:$quantity.' '.$printtext).(($quantity > 1 AND $contingent == 1)?' '.$print_anz:'');
									break;
							}
							$inpfld_1a = '';
							$inpfld_1b = '';
							$inpfld_2a = '';
							$inpfld_2b = '';
							if($to == 'newcalc' AND $inv_id > 0){
								$inpfld_1a = '<input'.$disable_modify.' type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
								$tabind++;
								$inpfld_1a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',\''.$m.'\',\''.$inv_id.'\',false);" maxlength="6" style="text-align:right;width:55%" value="';
								$inpfld_1b = '" />';
								$inpfld_2a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
								$tabind++;
								$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
								$inpfld_2b = '" />';
							}
							$price_tabmore .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$more_name.($external==1?'*':'').'</td>';
							$price_tabmore .= '<td align="center">'.$print_quantity.'</td>';
							$price_tabmore .= '<td align="right">'.$inpfld_1a.number_format($single_price,2,$dec_point,$thousends).$inpfld_1b.' '.$p_unit.'</td>';
							$price_tabmore .= '<td align="right">'.$inpfld_2a.number_format($gp,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
							if(($to=='billet' OR $to=='newcalc') AND $show_vats > 0){
								if($external == 0){
									$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
									$vatid = ($vatid==''?'B':$vatid);
									$base_gp = $vats[$vatid]['base_price']+$gp;
									$vats[$vatid]['base_price']=$base_gp;
									$price_tabmore .= '<td align="center">';
									if($to=='newcalc'){
										$price_tabmore .= '<select name="vatid_'.$inv_id.'" onchange="set_newvat_calc_button(\''.$inv_id.'\',\''.$gp.'\',\''.$m.'\',this.value,\''.$vatid.'\',false);">';
										foreach($vats AS $vid => $varr){
											$select = ($vatid==$vid?' selected="selected"':'');
											$price_tabmore .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
										}
										$price_tabmore .= '</select>';
									}
									else{ $price_tabmore .= $vatid; }
									$price_tabmore .= '</td>';
								}
								else{ $price_tabmore .= '<td align="center">&nbsp;</td>'; }
							}
							$price_tabmore .= '</tr>';
						}
					}
				}
				$price_table .= (!empty($price_tabmore)?$price_morehead.$price_tabmore:'');
			}
			$adds_prices = $tp['adds_price_fix'];
			if(count($adds_prices) > 0){
				$price_table .= '<tr'.($to=='newcalc'?' class="row_b"':'').'><td colspan="'.$colspanning.'">'.$CALTEXT['ADDS_INFO'].' - '.$CALTEXT['ADDS_ADDS'].':</td></tr>';
				foreach($adds_prices AS $item_id => $v_arr){
					$quantity = $v_arr[0];
					$single_price = $v_arr[1];
					$ppp = $v_arr[2];
					$external = (isset($v_arr[3])?$v_arr[3]:0);
					$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
					$m = $quantity;
					$gp = $m * $single_price;
					if($m > 0){
						if($to == 'newcalc' OR $single_price > 0){
							$getadds_extplus = $datapdo->query("SELECT `only_ext_persons`,`adds_alldays` FROM `".TABLE_PREFIX."res_price_adds` WHERE `rpadds_id`='$item_id' LIMIT 0,1");
							if($datapdo->numRows($getadds_extplus)>0){
								$extplus = $datapdo->fetchRow($getadds_extplus);
								$adds_ext = $extplus['only_ext_persons'];
								$adds_plus = $extplus['adds_alldays'];
								$adds_name = get_name_addkey($item_id,'adds',$s,$lang);

								if(empty($adds_name) AND $to=='newcalc'){
									$get_curradds = $datapdo->query("SELECT `rpadds_id` FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$o' AND `isold`='0'");
									if($datapdo->numRows($get_curradds)>0){
										$adds_name = '<select name="newadd'.$item_id.'" onchange="set_newadd(\''.$r.'\',\'adds\','.$item_id.',this.value);" style="width:80%;">'."\n";
										$adds_name .= '<option value="0">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</option>'."\n";
										while($curradds = $datapdo->fetchRow($get_curradds)){
											$adds_name .= '<option value="'.$curradds['rpadds_id'].'">'.get_name_addkey($curradds['rpadds_id'],'adds',$s,$lang).'</option>'."\n";
										}
										$adds_name .= '</select>'."\n";
										$adds_ext = 0;
										$adds_plus = 0;
										$adds_external = 0;
									}
								}
							}
							else{
								if($to=='newcalc'){
									$get_curradds = $datapdo->query("SELECT `rpadds_id` FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$o' AND `isold`='0'");
									if($datapdo->numRows($get_curradds)>0){
										$adds_name = '<select name="newadd'.$item_id.'" onchange="set_newadd(\''.$r.'\',\'adds\','.$item_id.',this.value);" style="width:80%;">'."\n";
										$adds_name .= '<option value="0">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</option>'."\n";
										while($curradds = $datapdo->fetchRow($get_curradds)){
											$adds_name .= '<option value="'.$curradds['rpadds_id'].'">'.get_name_addkey($curradds['rpadds_id'],'adds',$s,$lang).'</option>'."\n";
										}
										$adds_name .= '</select>'."\n";
										$adds_ext = 0;
										$adds_plus = 0;
										$adds_external = 0;
									}
								}
								else{
									$adds_ext = 0;
									$adds_plus = 0;
									$adds_external = 0;
									$adds_name = '<span style="color:red">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</span>';
								}
							}
							$div_pers = (($adds_ext > 0)?$ext_pers:$allpersons);
							//$div_pers = $allpersons;
							$print_anz = ($adds_plus > 0?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1));
							$item_id_text = 'ADDS_'.$item_id;
							$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
							$type = (isset($v_arr[2])?$v_arr[2]:0);
							$adults = $allpersons - $children - $toddler;
							switch ($type){
								case 12:
									$pers_ae = $allpersons-$toddler;
									$div_pers = ($ext_pers < $pers_ae?$ext_pers:$pers_ae);
									$print_temp0 = $CALTEXT['PERSONS'];
									$print_temp1 = $CALTEXT['ADULTS'];
									$print_temp2 = $CALTEXT['CHILDREN'];
									$print_pers = $div_pers;
									$print_persons = (($children==0 OR $adults==0)?mb_substr($print_temp0,0,1):mb_substr($print_temp1,0,3).'+'.mb_substr($print_temp2,0,2));
									$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
									if($print_quantity>0){
										$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
										$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
									}
									break;
								case 11:
									$quant_adults = $quantity-$toddler;
									if($quant_adults == $quantity OR $children == $quantity){
										$print_quantity = $quantity.' '.mb_substr($CALTEXT['PERSONS'],0,1);
									}
									else{
										$print_quantity = $quant_adults.' '.mb_substr($CALTEXT['ADULTS'],0,3).'+'.$children.' '.mb_substr($CALTEXT['CHILDREN'],0,2);
									}
									break;
								case 10:
									$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['ADULTS'],0,3));
									break;
								case 9:
									$print_temp = $CALTEXT['TODDLER'];
									$print_pers = $toddler;
									$print_persons = mb_substr($print_temp,0,2);
									$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
									if($print_quantity>0){
										$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
										$print_quantity = $print_quantity.' '.$print_anz.' * '.$print_pers.' '.$print_persons;
									}
									break;
								case 8:
									$print_quantity = $quantity.' '.mb_substr($CALTEXT['TODDLER'],0,2);
									break;
								case 7:
									$print_quantity = $quantity.' '.mb_substr($CALTEXT['CHILDREN'],0,2);
									break;
								case 6:
									$div_pers = (($adds_ext > 0 AND $ext_pers < $children)?$ext_pers:$children);
									$print_temp = $CALTEXT['CHILDREN'];
									$print_pers = $div_pers;
									$print_persons = mb_substr($print_temp,0,2);
									$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
									if($print_quantity>0){
										$print_anz = (($print_quantity <> ($date_days + $adds_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
										$print_quantity = $print_quantity.' '.$print_anz.' * '.$print_pers.' '.$print_persons;
									}
									break;
								case 5:
									$div_pers = (($adds_ext > 0 AND $ext_pers < $adults)?$ext_pers:$adults);
									$print_pers = $div_pers;
									$print_temp = (($children>0 OR $toddler>0)?$CALTEXT['ADULTS']:$CALTEXT['PERSONS']);
									$chars = (($children>0 OR $toddler>0)?3:1);
									$print_persons = mb_substr($print_temp,0,$chars);
									$print_quantity = ($print_pers>0?($quantity / $print_pers):$allpersons);
									$print_anz = (($print_quantity <> ($date_days + $adds_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
									$print_quantity = $print_quantity.' '.$print_anz.' * '.$print_pers.' '.$print_persons;
									break;
								case 4:
									$div_pers = (($adds_ext > 0 AND $ext_pers > 0)?$ext_pers:$allpersons);
									$print_temp = $CALTEXT['PERSONS'];
									$print_pers = $div_pers;
									$print_persons = mb_substr($print_temp,0,1);
									$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
									$print_anz = (($print_quantity <> ($date_days + $adds_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
									$print_quantity = $print_quantity.' '.$print_anz.' * '.$print_pers.' '.$print_persons;
									break;
								case 3:
									$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==($date_days + $adds_plus)) ? ($date_days + $adds_plus).' '.$print_anz.' * '.$contingent.' '.mb_substr($CALTEXT['CONTINGENTS'],0,1):$quantity).(($quantity > 1 AND $contingent == 1)?' '.$print_anz:'');
									break;
								case 2:
									$print_quantity = $quantity.' '.mb_substr($CALTEXT['PERSONS'],0,1);
									break;
								case 1:
									$print_quantity = $quantity.' '.mb_substr($CALTEXT['CONTINGENTS'],0,1);
									break;
								case 0:
								default:
									$print_quantity = $quantity;
//									$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==($date_days + $adds_plus)) ? ($date_days + $adds_plus).' '.$print_anz.' * '.$contingent.' '.$printtext:$quantity.' '.$printtext).(($quantity > 1 AND $contingent == 1)?' '.$print_anz:'');
									break;
							}
							$inpfld_1a = '';
							$inpfld_1b = '';
							$inpfld_2a = '';
							$inpfld_2b = '';
							if($to == 'newcalc' AND $inv_id > 0){
								$inpfld_1a = '<input'.$disable_modify.' type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
								$tabind++;
								$inpfld_1a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',\''.$m.'\',\''.$inv_id.'\',false);" maxlength="6" style="text-align:right;width:55%" value="';
								$inpfld_1b = '" />';
								$inpfld_2a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
								$tabind++;
								$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
								$inpfld_2b = '" />';
							}
							$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$adds_name.'</td>'; //.($external==1?'*':'').'</td>';
							$price_table .= '<td align="center">'.$print_quantity.'</td>';
							$price_table .= '<td align="right">'.$inpfld_1a.number_format($single_price,2,$dec_point,$thousends).$inpfld_1b.' '.$p_unit.'</td>';
							$price_table .= '<td align="right">'.$inpfld_2a.number_format($gp,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
							if(($to=='billet' OR $to == 'newcalc') AND $show_vats > 0){
								if($external == 0){
									$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
									$vatid = ($vatid==''?'B':$vatid);
									$base_gp = $vats[$vatid]['base_price']+$gp;
									$vats[$vatid]['base_price']=$base_gp;
									$price_table .= '<td align="center">';
									if($to=='newcalc'){
										$price_table .= '<select name="vatid_'.$inv_id.'" onchange="set_newvat_calc_button(\''.$inv_id.'\',\''.$gp.'\',\''.$m.'\',this.value,\''.$vatid.'\',false);">';
										foreach($vats AS $vid => $varr){
											$select = ($vatid==$vid?' selected="selected"':'');
											$price_table .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
										}
										$price_table .= '</select>';
									}
									else{ $price_table .= $vatid; }
									$price_table .= '</td>';
								}
								else{
									$price_table .= '<td align="center">&nbsp;</td>';
								}
							}
							$price_table .= '</tr>';
						}
					}
				}
			}
		}
		else{
			$item_id_tmp = '';
			$seas_count = 1;
			foreach($book_prices1 AS $item_id => $v_arr){
				$quantity = $v_arr[0];
				$single_price = $v_arr[1];
				$price_withoutdisc = $price_withoutdisc + ($quantity * $single_price);
				$ppp = $v_arr[2];
				$item_id_text = $item_id.'_1';
				$item_id_out = substr($item_id,0,8);
				if($item_id_out == $item_id_tmp){
					$seas_count++;
				}
				else{ $seas_count = 1; }
				$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
				if($ppp > 0 AND $price_type > 0) {
					$printpers = ($children > 0?mb_substr($CALTEXT['ADULTS'],0,3):mb_substr($CALTEXT['PERSONS'],0,1));
					$print_days = $quantity / $persons;
					$print_quantity = $print_days.' '.($showdays==1?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1)).' * '.$persons.' '.$printpers;
				}
				else{
					$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==$date_days) ? $date_days.' '.($showdays==1?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1)).' * '.$contingent.' '.mb_substr($CALTEXT['CONTINGENTS'],0,1):$quantity.' '.($showdays==1?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1)));
				}
				$info = '';
				if(empty($tp['fp_info'])){
					if($date_days < $res_days){
						$info = '<br />'.$CALTEXT['MIN_INFO_SHORT'].' '.$res_days.' '.($showdays==1?$TEXT['TERMIN_ANZ']:$TEXT['TERMIN_ANZN']).'!';
					}
				}
				elseif(!empty($tp['fp_info'])){
					$info = '<br />'.$tp['fp_info'];
				}
				$print_quantity .= $info;
				$inpfld_1a = '';
				$inpfld_1b = '';
				$inpfld_2a = '';
				$inpfld_2b = '';
				$m = $quantity;
				$gp = $m * $single_price;
				if($to == 'newcalc' AND $inv_id > 0){
					$inpfld_1a = '<input'.$disable_modify.' type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
					$tabind++;
					$inpfld_1a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',\''.$m.'\',\''.$inv_id.'\',true);" maxlength="6" style="text-align:right;width:55%" value="';
					$inpfld_1b = '" />';
					$inpfld_2a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
					$tabind++;
					$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
					$inpfld_2b = '" />';
				}
				$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.(($seas_count>0 AND $item_id_tmp == $item_id_out)?$seas_count.'. ':'').$CALTEXT[$item_id_out].'</td>';
				$item_id_tmp = substr($item_id,0,8);
				$price_table .= '<td align="center">'.$print_quantity.'</td>';
				$price_table .= '<td align="right">'.$inpfld_1a.number_format($single_price,2,$dec_point,$thousends).$inpfld_1b.' '.$p_unit.'</td>';
				$price_table .= '<td align="right">'.$inpfld_2a.number_format($gp,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
				if(($to=='billet' OR $to == 'newcalc') AND $show_vats > 0){
					$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
					$base_gp = $vats[$vatid]['base_price']+$gp;
					$vats[$vatid]['base_price']=$base_gp;
					$price_table .= '<td align="center">';
					if($to=='newcalc'){
						$price_table .= '<select name="vatid_'.$inv_id.'" onchange="set_newvat_calc_button(\''.$inv_id.'\',\''.$gp.'\',\''.$m.'\',this.value,\''.$vatid.'\',true);">';
						foreach($vats AS $vid => $varr){
							$select = ($vatid==$vid?' selected="selected"':'');
							$price_table .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
						}
						$price_table .= '</select>';
					}
					else{ $price_table .= $vatid; }
					$price_table .= '</td>';
				}
				$price_table .= '</tr>';
			}

			$book_prices2 = $tp['book_prices2'];
			if(count($book_prices2) > 0 AND $children > 0){
				foreach($book_prices2 AS $item_id => $v_arr){
					$quantity = $v_arr[0];
					$single_price = $v_arr[1];
					$price_withoutdisc = $price_withoutdisc + ($quantity * $single_price);
					$ppp = $v_arr[2];
					$item_id_text = $item_id.'_2';
					$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
					if($ppp > 0){
						$print_days = $quantity / $children;
						$print_quantity = $print_days.' '.($showdays==1?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1)).' * '.$children.' '.mb_substr($CALTEXT['CHILDREN'],0,2);
					}
					else{
						$print_quantity = $quantity.' '.($showdays==1?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1));
					}
					$inpfld_1a = '';
					$inpfld_1b = '';
					$inpfld_2a = '';
					$inpfld_2b = '';
					$m = $quantity;
					$gp = $m * $single_price;
					if($to == 'newcalc' AND $inv_id > 0){
						$inpfld_1a = '<input'.$disable_modify.' type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
						$tabind++;
						$inpfld_1a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',\''.$m.'\',\''.$inv_id.'\',true);" maxlength="6" style="text-align:right;width:55%" value="';
						$inpfld_1b = '" />';
						$inpfld_2a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
						$tabind++;
						$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
						$inpfld_2b = '" />';
					}
					$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$CALTEXT[$item_id].' ('.$CALTEXT['DISCOUNT_TYPE_0'].')</td>';
					$price_table .= '<td align="center">'.$print_quantity.'</td>';
					$price_table .= '<td align="right">'.$inpfld_1a.number_format($single_price,2,$dec_point,$thousends).$inpfld_1b.' '.$p_unit.'</td>';
					$price_table .= '<td align="right">'.$inpfld_2a.number_format($gp,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
					if(($to=='billet' OR $to == 'newcalc') AND $show_vats > 0){
						$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
						$base_gp = $vats[$vatid]['base_price']+$gp;
						$vats[$vatid]['base_price']=$base_gp;
						$price_table .= '<td align="center">';
						if($to=='newcalc'){
							$price_table .= '<select name="vatid_'.$inv_id.'" onchange="set_newvat_calc_button(\''.$inv_id.'\',\''.$gp.'\',\''.$m.'\',this.value,\''.$vatid.'\',true);">';
							foreach($vats AS $vid => $varr){
								$select = ($vatid==$vid?' selected="selected"':'');
								$price_table .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
							}
							$price_table .= '</select>';
						}
						else{ $price_table .= $vatid; }
						$price_table .= '</td>';
					}
					$price_table .= '</tr>';
				}
			}
			$book_prices3 = (isset($tp['book_prices3'])?$tp['book_prices3']:array());
			if(count($book_prices3) > 0 AND $toddler > 0){
				foreach($book_prices3 AS $item_id => $v_arr){
					$quantity = $v_arr[0];
					$single_price = $v_arr[1];
					$price_withoutdisc = $price_withoutdisc + ($quantity * $single_price);
					$ppp = $v_arr[2];
					$item_id_text = $item_id.'_3';
					$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
					if($ppp > 0){
						$print_days = $quantity / $toddler;
						$print_quantity = $print_days.' '.($showdays==1?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1)).' * '.$toddler.' '.mb_substr($CALTEXT['TODDLER'],0,2);
					}
					else{
						$print_quantity = $quantity.' '.($showdays==1?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1));
					}
					$inpfld_1a = '';
					$inpfld_1b = '';
					$inpfld_2a = '';
					$inpfld_2b = '';
					$m = $quantity;
					$gp = $m * $single_price;
					if($to == 'newcalc' AND $inv_id > 0){
						$inpfld_1a = '<input'.$disable_modify.' type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
						$tabind++;
						$inpfld_1a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',\''.$m.'\',\''.$inv_id.'\',true);" maxlength="6" style="text-align:right;width:55%" value="';
						$inpfld_1b = '" />';
						$inpfld_2a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
						$tabind++;
						$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
						$inpfld_2b = '" />';
					}
					$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$CALTEXT[$item_id].' ('.$CALTEXT['DISCOUNT_TYPE_4'].')</td>';
					$price_table .= '<td align="center">'.$print_quantity.'</td>';
					$price_table .= '<td align="right">'.$inpfld_1a.number_format($single_price,2,$dec_point,$thousends).$inpfld_1b.' '.$p_unit.'</td>';
					$price_table .= '<td align="right">'.$inpfld_2a.number_format($gp,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
					if(($to=='billet' OR $to == 'newcalc') AND $show_vats > 0){
						$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
						$base_gp = $vats[$vatid]['base_price']+$gp;
						$vats[$vatid]['base_price']=$base_gp;
						$price_table .= '<td align="center">';
						if($to=='newcalc'){
							$price_table .= '<select name="vatid_'.$inv_id.'" onchange="set_newvat_calc_button(\''.$inv_id.'\',\''.$gp.'\',\''.$m.'\',this.value,\''.$vatid.'\',true);">';
							foreach($vats AS $vid => $varr){
								$select = ($vatid==$vid?' selected="selected"':'');
								$price_table .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
							}
							$price_table .= '</select>';
						}
						else{ $price_table .= $vatid; }
						$price_table .= '</td>';
					}
					$price_table .= '</tr>';
				}
			}

			$holi_prices = $tp['holi_price'];
			if(count($holi_prices) > 0){
				$price_table .= '<tr'.($to=='newcalc'?' class="row_b"':'').'><td colspan="'.$colspanning.'">'.$CALTEXT['ADDS_INFO'].' - '.$CALTEXT['ADDS_HOLI'].':</td></tr>';
				foreach($holi_prices AS $item_id => $v_arr){
					if($item_id >= 400){
						$holi_name = (isset($CALTEXT['HOLI_'.$item_id])?$CALTEXT['HOLI_'.$item_id]:$TEXT['UNKNOWN']);
					}
					else{
						$holi_name = gmdate(DATE_FORMAT,mktime(12,0,0,1,$item_id,$v_arr[3])).(isset($CALTEXT['HOLI_'.$item_id])?' - '.$CALTEXT['HOLI_'.$item_id]:'');
					}
					$item_id_text = 'HOLI_'.$item_id;
					$quantity = $v_arr[0];
					$single_price = $v_arr[1];
					$price_withoutdisc = $price_withoutdisc + ($quantity * $single_price);
					$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
					if($allpersons > 0 AND $quantity > 1 AND ($quantity / $allpersons) == $date_days){
						$print_quantity = $date_days.' '.mb_substr($TEXT['TERMIN_ANZ'],0,1).' * '.$allpersons.' '.mb_substr($CALTEXT['PERSONS'],0,1);
					}
					elseif($allpersons > 0 AND $quantity == $allpersons){
						$print_quantity = ($quantity / $allpersons).' '.mb_substr($TEXT['TERMIN_ANZ'],0,1).' * '.$allpersons.' '.mb_substr($CALTEXT['PERSONS'],0,1);
					}
					else{
						$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==$date_days) ? $date_days.' '.mb_substr($TEXT['TERMIN_ANZ'],0,1).' * '.$contingent.' '.mb_substr($CALTEXT['CONTINGENTS'],0,1):$quantity.' '.($contingent > 1?mb_substr($CALTEXT['CONTINGENTS'],0,1):mb_substr($TEXT['TERMIN_ANZ'],0,1)));
					}
					$inpfld_1a = '';
					$inpfld_1b = '';
					$inpfld_2a = '';
					$inpfld_2b = '';
					$m = $quantity;
					$gp = $m * $single_price;
					if($to == 'newcalc' AND $inv_id > 0){
						$inpfld_1a = '<input'.$disable_modify.' type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
						$tabind++;
						$inpfld_1a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',\''.$m.'\',\''.$inv_id.'\',true);" maxlength="6" style="text-align:right;width:55%" value="';
						$inpfld_1b = '" />';
						$inpfld_2a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
						$tabind++;
						$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
						$inpfld_2b = '" />';
					}
					$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$holi_name.'</td><td align="center">'.$print_quantity.'</td>';
					$price_table .= '<td align="right">'.$inpfld_1a.number_format($single_price,2,$dec_point,$thousends).$inpfld_1b.' '.$p_unit.'</td>';
					$price_table .= '<td align="right">'.$inpfld_2a.number_format($gp,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
					if(($to=='billet' OR $to == 'newcalc') AND $show_vats > 0){
						$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
						$base_gp = $vats[$vatid]['base_price']+$gp;
						$vats[$vatid]['base_price']=$base_gp;
						$price_table .= '<td align="center">';
						if($to=='newcalc'){
							$price_table .= '<select name="vatid_'.$inv_id.'" onchange="set_newvat_calc_button(\''.$inv_id.'\',\''.$gp.'\',\''.$m.'\',this.value,\''.$vatid.'\',true);">';
							foreach($vats AS $vid => $varr){
								$select = ($vatid==$vid?' selected="selected"':'');
								$price_table .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
							}
							$price_table .= '</select>';
						}
						else{ $price_table .= $vatid; }
						$price_table .= '</td>';
					}
					$price_table .= '</tr>';
				}
			}

			$discounts = $tp['discounts'];
			if(count($discounts) > 0){
				if($to=='newcalc'){
					$inpfld_2a = '<input disabled type="text" id="book_gp" name="subtotal" tabindex="';
					$tabind++;
					$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
					$inpfld_2b = '" />';
					$price_table .= '<tr><td colspan="3" align="right">'.$CALTEXT['SUM_PRICES'].':</td><td align="right">'.$inpfld_2a.number_format($price_withoutdisc,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				}
				$price_table .= '<tr'.($to=='newcalc'?' class="row_b"':'').'><td colspan="'.$colspanning.'">'.$CALTEXT['PRICE_DISCOUNTS'].':</td></tr>';
				foreach($discounts AS $item_id => $v_arr){
					$item_id_text = 'DISC_'.$item_id;
					$disc_name = $CALTEXT['DISCOUNT_TYPE_'.$item_id];
					$quantity = $v_arr[0];
					if($to=='billet' AND $show_vats > 0){
						foreach($vats AS $vid => $varr){
							$new_base_price=$varr['base_price'] - ($varr['base_price']*$quantity / 100);
							$vats[$vid]['base_price']=$new_base_price;
						}
					}
					$single_price = round($v_arr[1],2,PHP_ROUND_HALF_DOWN);
if($price_set['roundprice']==1){ $single_price = round(($single_price*2),1)/2; }
					$inv_id = (isset($v_arr[2])?$v_arr[2]:0);
					$inpfld_1a = '';
					$inpfld_1b = '';
					$inpfld_2a = '';
					$inpfld_2b = '';
					if($to == 'newcalc' AND $inv_id > 0){
						$inpfld_1a = '<input'.$disable_modify.' type="text" name="quantity_'.$inv_id.'" tabindex="';
						$tabind++;
						$inpfld_1a .= $tabind.'" onchange="calc_newdiscount(this.value,\''.$inv_id.'\');" maxlength="2" style="text-align:right;width:55%" value="';
						$inpfld_1b = '" />';
						$inpfld_2a = '<input disabled type="text" id="dgp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
						$tabind++;
						$inpfld_2a .= $tabind.'" style="text-align:right;width:55%" value="';
						$inpfld_2b = '" />';
					}
					$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$disc_name.'</td>';
					$price_table .= '<td align="center">'.$inpfld_1a.$quantity.$inpfld_1b.' %</td><td>&nbsp;</td>';
					$price_table .= '<td align="right">- '.$inpfld_2a.number_format($single_price,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				}
			}
			$more_prices = $tp['more_price'];
			if(count($more_prices) > 0){
				$price_table .= '<tr'.($to=='newcalc'?' class="row_b"':'').'><td colspan="'.$colspanning.'">'.$CALTEXT['ADDS_INFO'].' - '.$CALTEXT['ADDS_MORE'].':</td></tr>';
				foreach($more_prices AS $item_id => $v_arr){
					$get_more_data = $datapdo->query("SELECT `more_alldays`,`external`,`more_key` FROM `".TABLE_PREFIX."res_price_more` WHERE `section_id`='$s' AND `rpmore_id`='$item_id' LIMIT 0,1");
					if($datapdo->numRows($get_more_data)>0){
						$more_name = get_name_addkey($item_id,'more',$s,$lang);
						$more_data = $datapdo->fetchRow($get_more_data);
						$more_plus = $more_data['more_alldays'];
						$more_external = $more_data['external'];
						$more_fld = $more_data['more_key'];
					}
					else{
						if($to=='newcalc'){
							$get_currmores = $datapdo->query("SELECT `rpmore_id` FROM `".TABLE_PREFIX."res_price_more` WHERE `object_id`='$o' AND `isold`='0'");
							if($datapdo->numRows($get_currmores)>0){
								$more_name = '<select name="newadd'.$item_id.'" onchange="set_newadd(\''.$r.'\',\'more\','.$item_id.',this.value);" style="width:80%;">'."\n";
								$more_name .= '<option value="0">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</option>'."\n";
								while($currmores = $datapdo->fetchRow($get_currmores)){
									$more_name .= '<option value="'.$currmores['rpmore_id'].'">'.get_name_addkey($currmores['rpmore_id'],'more',$s,$lang).'</option>'."\n";
								}
								$more_name .= '</select>'."\n";
								$more_fld = 0;
								$more_plus = 0;
								$more_external = 0;
							}
						}
						else{
							$more_fld = 0;
							$more_plus = 0;
							$more_external = 0;
							$more_name = '<span style="color:red;">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</span>';
						}
					}
					$have_external = ($more_external==1?true:$have_external);
					$print_anz = ($more_plus > 0?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1));
					$item_id_text = 'MORE_'.$item_id;
					$quantity = $v_arr[0];
					$single_price = $v_arr[1];
					if($more_external==1){ $price_external = $price_external + ($quantity * $single_price); }
//					$price_withoutdisc = $price_withoutdisc + ($quantity * $single_price);
					$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
					$type = (isset($v_arr[2])?$v_arr[2]:0);
					$adults = $allpersons - $children - $toddler;
					// Check the more field is radio or option
					$chk_field = $datapdo->get_one("SELECT `field_typ` FROM `".TABLE_PREFIX."forms` WHERE `field_id`='$more_fld' LIMIT 1");
					$is_ro = false;
					if($chk_field == 'RADIO' OR $chk_field == 'OPTION'){ $is_ro = true; }
					switch ($type){
						case 12:
							$pers_ae = $allpersons-$toddler;
							$div_pers = ($ext_pers < $pers_ae?$ext_pers:$pers_ae);
							$print_temp0 = $CALTEXT['PERSONS'];
							$print_temp1 = $CALTEXT['ADULTS'];
							$print_temp2 = $CALTEXT['CHILDREN'];
							$print_pers = $div_pers;
							$print_persons = (($children==0 OR $adults==0)?mb_substr($print_temp0,0,1):mb_substr($print_temp1,0,3).'+'.mb_substr($print_temp2,0,2));
							$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
							if($print_quantity>0){
								$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
								$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
							}
							break;
						case 11:
							$quant_adults = $quantity-$toddler;
							if($quant_adults == $quantity OR $children == $quantity){
								$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['PERSONS'],0,1));
							}
							else{
								$print_quantity = $quant_adults.($is_ro == true?'':' '.mb_substr($CALTEXT['ADULTS'],0,3).'+'.$children.' '.mb_substr($CALTEXT['CHILDREN'],0,2));
							}
							break;
						case 10:
							$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['ADULTS'],0,3));
							break;
						case 9:
							$print_temp = $CALTEXT['TODDLER'];
							$print_pers = $toddler;
							$print_persons = mb_substr($print_temp,0,2);
							$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
							if($print_quantity>0){
								$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
								$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
							}
							break;
						case 8:
							$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['TODDLER'],0,2));
							break;
						case 7:
							 $print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['CHILDREN'],0,2));
							 break;
						case 6:
							$div_pers = (($ext_pers > 0 AND $ext_pers < $children)?$ext_pers:$children);
							$print_temp = $CALTEXT['CHILDREN'];
							$print_pers = $div_pers;
							$print_persons = mb_substr($print_temp,0,2);
							$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
							if($print_quantity>0){
								$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
								$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
							}
							break;
						case 5:
							$div_pers = (($ext_pers > 0 AND $ext_pers < $adults)?$ext_pers:$adults);
							$print_pers = $div_pers;
							$print_temp = (($children>0 OR $toddler>0)?$CALTEXT['ADULTS']:$CALTEXT['PERSONS']);
							$chars = (($children>0 OR $toddler>0)?3:1);
							$print_persons = mb_substr($print_temp,0,$chars);
							$print_quantity = ($print_pers>0?$quantity / $print_pers:$allpersons);
							$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
							$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
							break;
						case 4:
							$div_pers = $allpersons;
//							$div_pers = ($ext_pers > 0?$ext_pers:$allpersons);
							$print_temp = $CALTEXT['PERSONS'];
							$print_pers = $div_pers;
							$print_temp = $CALTEXT['PERSONS'];
							$print_pers = $div_pers;
							$print_persons = mb_substr($print_temp,0,1);
							$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
							$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
							$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
							break;
						case 3:
							$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==($date_days + $more_plus)) ? ($date_days + $more_plus).' '.$print_anz.' * '.$contingent.' '.mb_substr($CALTEXT['CONTINGENTS'],0,1):$quantity).(($quantity > 1 AND $contingent == 1)?' '.$print_anz:'');
							break;
						case 2:
							$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['PERSONS'],0,1));
							break;
						case 1:
							$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['CONTINGENTS'],0,1));
							break;
						case 0:
						default:
							$print_quantity = $quantity;
//							$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==($date_days + $adds_plus)) ? ($date_days + $adds_plus).' '.$print_anz.' * '.$contingent.' '.$printtext:$quantity.' '.$printtext).(($quantity > 1 AND $contingent == 1)?' '.$print_anz:'');
							break;
					}
					$inpfld_1a = '';
					$inpfld_1b = '';
					$inpfld_2a = '';
					$inpfld_2b = '';
					$m = $quantity;
					$gp = $m * $single_price;
					if($m >0){
						if($to == 'newcalc' AND $inv_id > 0){
							$inpfld_1a = '<input'.$disable_modify.' type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
							$tabind++;
							$inpfld_1a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',\''.$m.'\',\''.$inv_id.'\',false);" maxlength="6" style="text-align:right;width:55%" value="';
							$inpfld_1b = '" />';
							$inpfld_2a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
							$tabind++;
							$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
							$inpfld_2b = '" />';
						}
						$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$more_name.($more_external==1?'*':'').'</td><td align="center">'.$print_quantity.'</td>';
						$price_table .= '<td align="right">'.$inpfld_1a.number_format($single_price,2,$dec_point,$thousends).$inpfld_1b.' '.$p_unit.'</td>';
						$price_table .= '<td align="right">'.$inpfld_2a.number_format($gp,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
						if(($to=='billet' OR $to == 'newcalc') AND $show_vats > 0){
							if($more_external==0){
								$queryvatid = "SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1";
								$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
								$base_gp = $vats[$vatid]['base_price']+$gp;
								$vats[$vatid]['base_price']=$base_gp;
								$price_table .= '<td align="center">';
								if($to=='newcalc'){
									$price_table .= '<select name="vatid_'.$inv_id.'" onchange="set_newvat_calc_button(\''.$inv_id.'\',\''.$gp.'\',\''.$m.'\',this.value,\''.$vatid.'\',false);">';
									foreach($vats AS $vid => $varr){
										$select = ($vatid==$vid?' selected="selected"':'');
										$price_table .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
									}
									$price_table .= '</select>';
								}
								else{ $price_table .= $vatid; }
								$price_table .= '</td>';
							}
							else{ $price_table .= '<td align="center">&nbsp;</td>'; }
						}
						$price_table .= '</tr>';
					}
				}
			}
			$adds_prices = $tp['adds_price'];
			if(count($adds_prices) > 0){
				$price_table .= '<tr'.($to=='newcalc'?' class="row_b"':'').'><td colspan="'.$colspanning.'">'.$CALTEXT['ADDS_INFO'].' - '.$CALTEXT['ADDS_ADDS'].':</td></tr>';
				foreach($adds_prices AS $item_id => $v_arr){
					$query_adds_data = "SELECT `adds_name`,`only_ext_persons`,`adds_alldays`,`external`,`addsstart` FROM `".TABLE_PREFIX."res_price_adds` WHERE `rpadds_id`='$item_id' LIMIT 0,1";
					$get_adds_data = $datapdo->query($query_adds_data);
					if($datapdo->numRows($get_adds_data)>0){
						$adds_data = $datapdo->fetchRow($get_adds_data);
						$adds_ext = $adds_data['only_ext_persons'];
						$adds_plus = $adds_data['adds_alldays'];
						$adds_external = $adds_data['external'];
						$adds_name = get_name_addkey($item_id,'adds',$s,$lang);
						if(empty($adds_name) AND $to=='newcalc'){
							$get_curradds = $datapdo->query("SELECT `rpadds_id` FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$o' AND `isold`='0'");
							if($datapdo->numRows($get_curradds)>0){
								$adds_name = '<select name="newadd'.$item_id.'" onchange="set_newadd(\''.$r.'\',\'adds\','.$item_id.',this.value);" style="width:80%;">'."\n";
								$adds_name .= '<option value="0">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</option>'."\n";
								while($curradds = $datapdo->fetchRow($get_curradds)){
									$adds_name .= '<option value="'.$curradds['rpadds_id'].'">'.get_name_addkey($curradds['rpadds_id'],'adds',$s,$lang).'</option>'."\n";
								}
								$adds_name .= '</select>'."\n";
								$adds_ext = 0;
								$adds_plus = 0;
								$adds_external = 0;
							}
						}
					}
					else{
						if($to=='newcalc'){
							$get_curradds = $datapdo->query("SELECT `rpadds_id` FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$o' AND `isold`='0'");
							if($datapdo->numRows($get_curradds)>0){
								$adds_name = '<select name="newadd'.$item_id.'" onchange="set_newadd(\''.$r.'\',\'adds\','.$item_id.',this.value);" style="width:80%;">'."\n";
								$adds_name .= '<option value="0">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</option>'."\n";
								while($curradds = $datapdo->fetchRow($get_curradds)){
									$adds_name .= '<option value="'.$curradds['rpadds_id'].'">'.get_name_addkey($curradds['rpadds_id'],'adds',$s,$lang).'</option>'."\n";
								}
								$adds_name .= '</select>'."\n";
								$adds_ext = 0;
								$adds_plus = 0;
								$adds_external = 0;
							}
						}
						else{
							$adds_ext = 0;
							$adds_plus = 0;
							$adds_external = 0;
							$adds_name = '<span style="color:red">'.$TEXT['UNKNOWN'].' ('.$TEXT['DELETED'].')</span>';
						}
					}
					$div_pers = (($adds_ext > 0 AND $ext_pers > 0)?$ext_pers:$allpersons);
//					$adds_name = $adds_n_array[$lang].(($adds_data['addsstart']>0 AND $adds_data['addsend']>0)?' ('.date(DATE_FORMAT,$adds_data['addsstart']).'-'.date(DATE_FORMAT,$adds_data['addsend']):'');
					$have_extarnal = ($adds_external==1?true:$adds_external);
					$print_anz = ($adds_plus > 0?mb_substr($TEXT['TERMIN_ANZ'],0,1):mb_substr($TEXT['TERMIN_ANZN'],0,1));
					$item_id_text = 'ADDS_'.$item_id;
					$quantity = $v_arr[0];
					$single_price = $v_arr[1];
					if($adds_external==1){ $price_external = $price_external + ($quantity * $single_price); }
//					$price_without_disc = $price_withoutdisc + ($quantity * $single_price);
					$inv_id = (isset($v_arr[4])?$v_arr[4]:0);
					$type = (isset($v_arr[2])?$v_arr[2]:0);
					$adults = $allpersons - $children - $toddler;
					switch ($type){
						case 12:
							$pers_ae = $allpersons-$toddler;
							$div_pers = ($ext_pers < $pers_ae?$ext_pers:$pers_ae);
							$print_temp0 = $CALTEXT['PERSONS'];
							$print_temp1 = $CALTEXT['ADULTS'];
							$print_temp2 = $CALTEXT['CHILDREN'];
							if($print_pers==0){ $print_pers = 1; }
							$print_persons = (($children==0 OR $adults==0)?mb_substr($print_temp0,0,1):mb_substr($print_temp1,0,3).'+'.mb_substr($print_temp2,0,2));
							$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
							if($print_quantity>0){
								$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
								$print_quantity = $print_quantity.' '.$print_anz.($is_ro == true?'':' * '.$print_pers.' '.$print_persons);
							}
							break;
						case 11:
							$quant_adults = $quantity-$toddler;
							if($quant_adults == $quantity OR $children == $quantity){
								$print_quantity = $quantity.' '.mb_substr($CALTEXT['PERSONS'],0,1);
							}
							else{
								$print_quantity = $quant_adults.' '.mb_substr($CALTEXT['ADULTS'],0,3).'+'.$children.' '.mb_substr($CALTEXT['CHILDREN'],0,2);
							}
							break;
						case 10:
							$print_quantity = $quantity.($is_ro == true?'':' '.mb_substr($CALTEXT['ADULTS'],0,3));
							break;
						case 9:
							$print_temp = $CALTEXT['TODDLER'];
							$print_pers = $toddler;
							$print_persons = mb_substr($print_temp,0,2);
							$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
							if($print_quantity>0){
								$print_anz = (($print_quantity > ($date_days + $more_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
								$print_quantity = $print_quantity.' '.$print_anz.' * '.$print_pers.' '.$print_persons;
							}
							break;
						case 8:
							$print_quantity = $quantity.' '.mb_substr($CALTEXT['TODDLER'],0,2);
							break;
						case 7:
							$print_quantity = $quantity.' '.mb_substr($CALTEXT['CHILDREN'],0,2);
							break;
						case 6:
							$div_pers = (($adds_ext > 0 AND $ext_pers < $children)?$ext_pers:$children);
							$print_temp = $CALTEXT['CHILDREN'];
							$print_pers = $div_pers;
							$print_persons = mb_substr($print_temp,0,2);
							$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
							if($print_quantity>0){
								$print_anz = (($print_quantity > ($date_days + $adds_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
								$print_quantity = $print_quantity.' '.$print_anz.' * '.$print_pers.' '.$print_persons;
							}
							break;
						case 5:
							$div_pers = (($adds_ext > 0 AND $ext_pers < $adults)?$ext_pers:$adults);
							$print_pers = $div_pers;
							$print_temp = (($children>0 OR $toddler>0)?$CALTEXT['ADULTS']:$CALTEXT['PERSONS']);
							$chars = (($children>0 OR $toddler>0)?3:1);
							$print_persons = mb_substr($print_temp,0,$chars);
							$print_quantity = ($print_pers>0?($quantity / $print_pers):$allpersons);
							$print_anz = (($print_quantity > ($date_days + $adds_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
							$print_quantity = $print_quantity.' '.$print_anz.' * '.$print_pers.' '.$print_persons;
							break;
						case 4:
							$div_pers = (($adds_ext > 0 AND $ext_pers > 0)?$ext_pers:$allpersons);
							$print_temp = $CALTEXT['PERSONS'];
							$print_pers = $div_pers;
							$print_persons = mb_substr($print_temp,0,1);
							$print_quantity = ($print_pers>0?($quantity / $print_pers):0);
							$print_anz = (($print_quantity > ($date_days + $adds_plus))?mb_substr($TEXT['TERMIN_ANZ'],0,1):$print_anz);
							$print_quantity = $print_quantity.' '.$print_anz.' * '.$print_pers.' '.$print_persons;
							break;
						case 3:
							$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==($date_days + $adds_plus)) ? ($date_days + $adds_plus).' '.$print_anz.' * '.$contingent.' '.mb_substr($CALTEXT['CONTINGENTS'],0,1):$quantity).(($quantity > 1 AND $contingent == 1)?' '.$print_anz:'');
							break;
						case 2:
							$print_quantity = $quantity.' '.mb_substr($CALTEXT['PERSONS'],0,1);
							break;
						case 1:
							$print_quantity = $quantity.' '.mb_substr($CALTEXT['CONTINGENTS'],0,1);
							break;
						case 0:
						default:
							$print_quantity = $quantity;
//							$print_quantity = (($contingent > 1 AND ($quantity / $contingent)==($date_days + $adds_plus)) ? ($date_days + $adds_plus).' '.$print_anz.' * '.$contingent.' '.$printtext:$quantity.' '.$printtext).(($quantity > 1 AND $contingent == 1)?' '.$print_anz:'');
							break;
					}
					$inpfld_1a = '';
					$inpfld_1b = '';
					$inpfld_2a = '';
					$inpfld_2b = '';
					$m = $quantity;
					$gp = $m * $single_price;
					if($m > 0){
						if($to == 'newcalc' AND $inv_id > 0){
							$inpfld_1a = '<input'.$disable_modify.' type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
							$tabind++;
							$inpfld_1a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',\''.$m.'\',\''.$inv_id.'\',false);" maxlength="6" style="text-align:right;width:55%" value="';
							$inpfld_1b = '" />';
							$inpfld_2a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
							$tabind++;
							$inpfld_2a .= $tabind.'" maxlength="6" style="text-align:right;width:55%" value="';
							$inpfld_2b = '" />';
						}
						if($gp > 0 OR $to=='newcalc'){
							$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$adds_name.'</td>'; // ($adds_external==1?'*':'').'</td>';
							$price_table .= '<td align="center">'.$print_quantity.'</td>';
							$price_table .= '<td align="right">'.$inpfld_1a.number_format($single_price,2,$dec_point,$thousends).$inpfld_1b.' '.$p_unit.'</td>';
							$price_table .= '<td align="right">'.$inpfld_2a.number_format($gp,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
							if(($to=='billet' OR $to == 'newcalc') AND $show_vats > 0){
								if($adds_external==0){
									$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
									$base_gp = $vats[$vatid]['base_price']+$gp;
									$vats[$vatid]['base_price']=$base_gp;
									$price_table .= '<td align="center">';
									if($to == 'newcalc'){
										$price_table .= '<select name="vatid_'.$inv_id.'" onchange="set_newvat_calc_button(\''.$inv_id.'\',\''.$gp.'\',\''.$m.'\',this.value,\''.$vatid.'\',false);">';
										foreach($vats AS $vid => $varr){
											$select = ($vatid==$vid?' selected="selected"':'');
											$price_table .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
										}
										$price_table .= '</select>';
									}
									else{ $price_table .= $vatid; }
									$price_table .= '</td>';
								}
								else{ $price_table .= '<td align="center">&nbsp;</td>'; }
							}
						}
						$price_table .= '</tr>';
					}
				}
			}
		}
		// Adds the lines of freefield prices
		$ffld_prices = $tp['ffld_price'];
		if(($to == 'billet' AND count($ffld_prices) > 0) OR $to == 'newcalc'){
			$price_table .= '<tr class="row_b"><td colspan="'.$colspanning.'">'.$CALTEXT['OTHER_PRICES'].':</td></tr>';
			$inv_id = 0;
			$add_ffld_fix = 0;
			for($i=0;$i<5;$i++){
				$inpfld_0a = '';
				$inpfld_0b = '';
				$inpfld_1a = '';
				$inpfld_1b = '';
				$inpfld_2a = '';
				$inpfld_2b = '';
				$inpfld_3a = '';
				$inpfld_3b = '';
				$item_id_text = 'FFLD_'.$i;
				if(isset($ffld_prices[$i])){
					$quantity = $ffld_prices[$i][0];
					$single_price = $ffld_prices[$i][1];
					$inv_id = $item_id_text;
					$ffld_name = get_ffld_name($r,$item_id_text);
					$m = $quantity;
					$gp = $m * $single_price;
					$add_ffld_fix += $gp;
					$vatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$r' AND `item_id`='$item_id_text' LIMIT 1");
				}
				else{
					$inv_id = $item_id_text;
					$quantity = 0;
					$single_price = 0;
					$ffld_name = '';
					$m = 0;
					$gp = $m * $single_price;
					$vatid = 'B';
				}
				if($to == 'newcalc'){
					$inpfld_0a = '<input type="text" name="content_'.$inv_id.'" tabindex="';
					$tabind++;
					$inpfld_0a .= $tabind.'" onchange="set_ffld_quantity(this.value,\''.$inv_id.'\');" style="text-align:leftt;width:98%;" value="';
					$inpfld_0b = '" />';
					$inpfld_1a = '<input type="text" id="quantity_'.$inv_id.'" name="quantity_'.$inv_id.'" tabindex="';
					$tabind++;
					$inpfld_1a .= $tabind.'" onchange="calc_numberformat(document.getElementById(\'single_price_'.$inv_id.'\'),document.getElementById(\'gp_'.$inv_id.'\').value,this.value,\''.$inv_id.'\',false)" style="text-align:center;width:30%" value="';
					$inpfld_1b = '" />';
					$inpfld_2a = '<input type="text" id="single_price_'.$inv_id.'" name="single_price_'.$inv_id.'" tabindex="';
					$tabind++;
					$inpfld_2a .= $tabind.'" onchange="calc_numberformat(this,\''.$gp.'\',document.getElementById(\'quantity_'.$inv_id.'\').value,\''.$inv_id.'\',false);" maxlength="10" style="text-align:right;width:55%" value="';
					$inpfld_2b = '" />';
					$inpfld_3a = '<input disabled type="text" id="gp_'.$inv_id.'" name="gp_'.$inv_id.'" tabindex="';
					$tabind++;
					$inpfld_3a .= $tabind.'" maxlength="10" style="text-align:right;width:55%" value="';
					$inpfld_3b = '" />';
				}
				if($gp <> 0 OR $to=='newcalc'){
					$price_table .= '<tr'.($to=='newcalc'?' class="row_a"':'').'><td>'.$inpfld_0a.$ffld_name.$inpfld_0b.'</td>'; // ($adds_external==1?'*':'').'</td>';
					$price_table .= '<td align="center">'.$inpfld_1a.$m.$inpfld_1b.'</td>';
					$price_table .= '<td align="right">'.$inpfld_2a.number_format($single_price,2,$dec_point,$thousends).$inpfld_2b.' '.$p_unit.'</td>';
					$price_table .= '<td align="right">'.$inpfld_3a.number_format($gp,2,$dec_point,$thousends).$inpfld_3b.' '.$p_unit.'</td>';
					if(($to=='billet' OR $to == 'newcalc') AND $show_vats > 0){
						$base_gp = $vats[$vatid]['base_price']+$gp;
						$vats[$vatid]['base_price']=$base_gp;
						$price_table .= '<td align="center">';
						if($to=='newcalc'){
							// Get all vats
							$price_table .= '<select name="vatid_'.$inv_id.'" onchange="show_ffldvat_calc_button(document.getElementById(\'gp_'.$inv_id.'\').value);">';
							foreach($vats AS $vid => $varr){
								$select = ($vatid==$vid?' selected="selected"':'');
								$price_table .= '<option value="'.$vid.'"'.$select.'>'.$vid.'</option>';
							}
							$price_table .= '</select>';
						}
						else{
							$price_table .= $vatid;
						}
						$price_table .= '</td>';
					}
				}
				$price_table .= '</tr>';
			}
		}
		$summ_price = ($fixed_price>0?$fixed_price+$add_ffld_fix:$total_price);
if($price_set['roundprice']==1){ $summ_price = round(($summ_price * 2),1)/2; }
		$print_summ = number_format($summ_price,2,$dec_point,$thousends);
		if($to=='form' OR $to=='billet'){
			if($price_external>0){
				$price_table .= '<tr><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['SUBTOTAL'].':</b></td><td align="right"><b>'.$print_summ.' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				$print_external = number_format($price_external,2,$dec_point,$thousends);
				$price_table .= '<tr><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['SERVICE_ADDS_PAY'].':</b></td><td align="right"><b>'.$print_external.' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				$summ_price = $summ_price - $price_external;
				$print_summ = number_format($summ_price,2,$dec_point,$thousends);
			}
			if($get_status == 0){ $out_totalprice = $CALTEXT['SUBTOTAL']; }else{ $out_totalprice = $CALTEXT['TOTALPRICE']; }
			$price_table .= '<tr><td colspan="3" style="text-align:right;"><b>'.$out_totalprice.':</b></td><td align="right"><b>'.$print_summ.' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
			if($to == 'billet' AND $get_status == 0){
				$subtract_storno = ($summ_price*(-1))+$add_ffld_fix;
				$resid_summ = $summ_price+$subtract_storno;
				$price_table .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['STORNO_SUBSTRACT'].':</b></td>';
				$price_table .= '<td align="right"><b>';
				$price_table .= number_format($subtract_storno,2,$dec_point,$thousends).'&nbsp;'.$p_unit.'</b></td></tr>';
				$price_table .= '<tr><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['RESIDUALPRICE'].':</b></td><td align="right"><b>'.number_format($resid_summ,2,$dec_point,$thousends).' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';

				$summ_price = $storno_price+$resid_summ;
				$price_table .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['IS_PAID'].':</b></td>';
				$price_table .= '<td align="right"><b>';
				$price_table .= number_format($paid_price,2,$dec_point,$thousends).'&nbsp;'.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				if($storno_price > 0){
					$out_stornotxt = ($storno_days==$res_days?$CALTEXT['STORNO_PRICE']:str_replace('[STORNODAYS]',$storno_days.' '.$daynight_txt,$CALTEXT['STORNO_PRICE_WITHDAY']));
					$print_storno = number_format($storno_price,2,$dec_point,$thousends);
					$price_table .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$out_stornotxt.':</b></td>';
					$price_table .= '<td id="stornopr" style="text-align:right;"><b>'.$print_storno.' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'');
					$price_table .= '</tr>';
				}
				$open_price = ($resid_summ*(-1))-$paid_price+$storno_price;
				$printtext = $CALTEXT['TO_PAY'];
				if($open_price < 0){
					$printtext = $CALTEXT['STORNOBACK'];
					$open_price = $open_price * (-1);
				}
				$price_table .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$printtext.':</b></td>';
				$price_table .= '<td id="topaypr" style="text-align:right;"><b>'.number_format($open_price,2,$dec_point,$thousends).' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
			}
			elseif($paid_price > 0){
				$open_price = $summ_price-$paid_price;
				$price_table .= '<tr><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['IS_PAID'].':</b></td><td style="text-align:right;"><b>'.number_format($paid_price,2,$dec_point,$thousends).' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				$price_table .= '<tr><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['TO_PAY'].':</b></td><td style="text-align:right;"><b>'.number_format($open_price,2,$dec_point,$thousends).' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
			}
		}
		else{
			if($price_external>0){
				$price_table .= '<tr><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['SUBTOTAL'].':</b></td><td align="right"><b>'.$print_summ.' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				$print_external = number_format($price_external,2,$dec_point,$thousends);
				$price_table .= '<tr><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['SERVICE_ADDS_PAY'].':<b><td align="right"><b>'.$print_external.' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				$summ_price = $summ_price - $price_external;
				$print_summ = number_format($summ_price,2,$dec_point,$thousends);
			}
			$price_table .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['TOTALPRICE'].':</b></td>';
			$price_table .= '<td id="totalpr" style="text-align:right;"><b>'.$print_summ.' '.$p_unit.'</b></td>';
			$price_table .= '<td id="calcbtn" class="hide" style="text-align:right;">';
			$price_table .= '<input type="submit" name="save" value="'.$CALTEXT['NEWCALC_RESPRICES'].'" style="width: 99%;" /></td>';
			$price_table .= ($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
			if($get_status == 0){
				$subtract_storno = ($summ_price*(-1))+$add_ffld_fix;
				$resid_summ = $summ_price+$subtract_storno;
				$storno_daystxt = '<input type="number" min="0" max="'.$res_days.'" value="'.$storno_days.'" onchange="set_new_storno_days('.$r.',this.value)" style="text-align:center;" />';
				$out_stornotxt = str_replace('[STORNODAYS]',$storno_daystxt.' '.$daynight_txt,$CALTEXT['STORNO_PRICE_WITHDAY']);
				$summ_price = $storno_price+$resid_summ;
				$print_storno = number_format($storno_price,2,$dec_point,$thousends);
				$price_table .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$out_stornotxt.':</b></td>';
				$price_table .= '<td id="stornopr" style="text-align:right;">';
				$price_table .= '<input id="storno_price" name="storno_price" value="';
				$price_table .= $print_storno;
				$price_table .= '" onchange="set_new_stornoprice('.$r.',this.value);" style="text-align:right;width:55%" />';
				$price_table .= ' '.$p_unit.'</td>'.($show_vats > 0?'<td>&nbsp;</td>':'');
				$price_table .= '</tr>';
				$open_price = ($resid_summ*(-1))-$paid_price+$storno_price;
			}
			else{
				$open_price = $summ_price-$paid_price;
			}
			$printtext = ($reminderstatus !== false?$CALTEXT['SUBTOTAL']:($open_price<0?$TEXT['TOTAL_CREDIT']:$CALTEXT['TO_PAY']));
			if($open_price<0){ $outopen = ($open_price*(-1)); }
			else{ $outopen = $open_price; }
			$price_table .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['IS_PAID'].':</b></td>';
			$price_table .= '<td align="right"><b>';
			$price_table .= '<input'.$disable_input.' style="text-align:right;font-weight:bold;width:55%;" name="paid_price" value="'.number_format($paid_price,2,$dec_point,$thousends).'" onchange="calc_paid_price(this);this.form.submit();" />&nbsp;'.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
			$price_table .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$printtext.':</b></td>';
			$price_table .= '<td id="'.($reminderstatus !== false?'remtopaypr':'topaypr').'" style="text-align:right;"><b>'.number_format($outopen,2,$dec_point,$thousends).' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
		}
		$print_fee = '';
		$print_mfee = '';
		$lastprice = 0;
		$feeprice = 0;
		$reminderdays = 0;
		$reminder_price = 0;
		$new_open = 0;
		if($reminderstatus !== false){
			$open_price = ((!isset($open_price) OR $open_price==0)?$summ_price:$open_price);
			// Ad to pricetable the reminder fee
			$get_remindersets = $datapdo->query("SELECT `reminderfee`,`reminderrent` FROM `".TABLE_PREFIX."res_paymentset` WHERE `object_id`='$o' LIMIT 0,1");
			if($datapdo->numRows($get_remindersets)>0){
				$remindersets = $datapdo->fetchRow($get_remindersets);
				$fee = $remindersets['reminderfee'];
				$rent = $remindersets['reminderrent'];
				$get_lastreminder = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_reminder` WHERE `res_id`='$r' ORDER BY `lastdate` DESC LIMIT 0,1");
				if($datapdo->numRows($get_lastreminder)>0){
					$lastreminder = $datapdo->fetchRow($get_lastreminder);
					$lastdate = $lastreminder['lastdate'];
					$reminderdays = ceil(((time()-$lastdate)/86400))+14;
					$lastprice = $lastreminder['reminder_price'];
					$open_price = $open_price + $lastprice;
					$print_fee .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['LASTREMINDER'].':</b></td>';
					$print_fee .= '<td id="lastfeepr" style="text-align:right;"><b>'.number_format($lastprice,2,$dec_point,$thousends).' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				}
				elseif($reminderdays==0){
					// Get the last bildate this reservation for set reminderdays
					$get_lastbil = $datapdo->get_one("SELECT `savedate` FROM `".TABLE_PREFIX."res_files` WHERE `res_id`='$r' AND (`tpl`='3' OR `tpl`='5') ORDER BY `savedate` DESC LIMIT 1");
					if($get_lastbil==0){
						// if not find a bil get the arrival date from reservation
						$get_lastbil =$datapdo->get_one("SELECT `res_start` FROM `".TABLE_PREFIX."reservations` WHERE `res_id`='$r' LIMIT 1");
					}
					$reminderdays = ceil(((time()-$get_lastbil)/86400))+7;
				}
				if($rent > 0 OR $fee > 0){
					$rent_multipl = $rent/100/360*$reminderdays;
					$rent_pr = $open_price*$rent_multipl;
					if($rent_pr > $fee){
						$feeprice = $rent_pr;
						$remindertext = str_replace(array('[RENT]','[PRICE]'),array($rent.' %',$open_price.' '.$p_unit),$CALTEXT['REMINDERRENT']);
					}
					else{
						$feeprice = $fee;
						$remindertext = $CALTEXT['REMINDERFEE'];
					}
					$print_fee .= '<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$remindertext.':</b></td>';
					$print_fee .= '<td id="rentpr" style="text-align:right;"><b>'.number_format($feeprice,2,$dec_point,$thousends).' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
				}
				if($print_fee != ''){
					$new_open = $open_price+$feeprice;
					$price_table .= $print_fee.'<tr class="row_b"><td colspan="3" style="text-align:right;"><b>'.$CALTEXT['TO_PAY'].':</b></td>';
					$price_table .= '<td id="topaypr" style="text-align:right;"><b>'.number_format($new_open,2,$dec_point,$thousends).' '.$p_unit.'</b></td>'.($show_vats > 0?'<td>&nbsp;</td>':'').'</tr>';
					$reminder_price = ($lastprice+$feeprice);
					$reminderstatus = $reminderstatus;
				}
			}
		}
		$price_table .= '</table>';
		$hiddenfields = array('RSTATUS'=>'','RPRICE'=>'','RSUBTRACT'=>'');
		if($reminderstatus !== false){
			$hiddenfields['RSTATUS'] = '<input type="hidden" name="reminderstatus" value="'.$reminderstatus.'" />';
			$hiddenfields['RPRICE'] = '<input type="hidden" name="reminder_price" value="'.$reminder_price.'" />';
			$hiddenfields['RSUBTRACT'] = '<input type="hidden" name="subtractpaid" value="'.$feeprice.'" />';
		}
		$price_vattable = '';
		if($to=='billet' AND $show_vats > 0 AND $get_status > 0){
			$total_vat = 0;
			$price_vattab = '';
			foreach($vats AS $vid => $varr){
				if($varr['base_price']==0){ continue; }
				$vatperc = ($varr['vat_percent'] / 100);
				$base_p = $varr['base_price'] / (1+$vatperc);
				$vat_p = $base_p * $vatperc;
				$vat_p = round($vat_p,2);
				$total_vat += $vat_p;
				$price_vattab .= '<tr><td style="text-align:left;">'.$TEXT[$varr['vat_fullname']].' - '.number_format($varr['vat_percent'],2,$dec_point,$thousends).' % ('.$vid.')</td>';
				$price_vattab .= '<td style="text-align:right;">'.number_format($base_p,2,$dec_point,$thousends).' '.$p_unit.'</td><td style="text-align:right;">'.number_format($vat_p,2,$dec_point,$thousends).' '.$p_unit.'</td></tr>';
			}

			$price_vattable .= '<br /><table width="80%" align="center" cellspacing="0" cellpadding="0">';
			$price_vattable .= '<tr><th style="width:50%;text-align:left;">'.$CALTEXT['CALCULATOR'].' '.$TEXT['VAT'].'</th>';
			$price_vattable .= '<th style="width:30%;text-align:right;">'.$CALTEXT['BASE_PRICE'].'</th>';
			$price_vattable .= '<th style="width:20%;text-align:right;">'.$TEXT['VAT_SHORT'].'</th></tr>';
			$price_vattable .= $price_vattab;
			$price_vattable .= '<tr><td colspan="2" style="width:80%;text-align:right;">'.$CALTEXT['VAT_BILLET'].'</td><td style="width:20%;text-align:right;">'.number_format($total_vat,2,$dec_point,$thousends).' '.$p_unit.'</td></tr>';
			$price_vattable .= '</table>';

		}
		if($have_external==true){
			$price_table .= '<p>* '.$CALTEXT['SERVICE_ADDS'].'</p>';
		}
		$price_table .= '</div>';
		if($to == 'newcalc'){
			$price_table .= '<script type="text/javascript">'."\n";
			$price_table .= 'function set_newadd(r,type,oldadd,newadd){'."\n";
			$price_table .= '    var addlink = "'.ADMIN_URL.'/reswervations/setnewadd.php?res="+r+"&type="+type+"&old="+oldadd+"&new="+newadd;'."\n";
			$price_table .= '    $("#noBox").load(addlink)'."\n";
//			$price_table .= '    location.reload();'."\n";
			$price_table .= '}'."\n";
			$price_table .= '</script>'."\n";
		}
	}
	$price_tables = array('CALC'=>$price_table,'VAT'=>$price_vattable,'REMINDER'=>$hiddenfields,'NEW_OPEN'=>$new_open);
	return $price_tables;
}
function get_provision_calc($object_id,$res_id,$numeral=false){
	global $datapdo,$TEXT;
	if(LANGUAGE != 'EN'){ $dec_point = ','; $thousends = '.'; }else{ $dec_point = '.'; $thousends = ','; }
	$retarray = NULL;
	$iscalc = false;
	$commission_price = 0;
	$fullcommprice = 0;
	$sbillingid = 0;
	// Check first we have tables for resbilling
	$get_tabs = $datapdo->query("SHOW TABLES LIKE '".TABLE_PREFIX."resbilling_o%'");
	if($datapdo->numRows($get_tabs)>0){
		// First look for object is configured and get the unit
		$roundprice = $datapdo->get_one("SELECT `roundprice` FROM `".TABLE_PREFIX."resbilling_settings` LIMIT 1");
		$get_obj = $datapdo->query("SELECT `commission_unit`,`commission`,`commission_storno` FROM `".TABLE_PREFIX."resbilling_objset` WHERE `object_id`='$object_id' AND `tpl`='1' LIMIT 0,1");
		if($datapdo->numRows($get_obj)>0){
			$obj = $datapdo->fetchRow($get_obj);
			$unit = $obj['commission_unit'];
			$commission = $obj['commission'] / 100;
			$commission_storno = $obj['commission_storno'] / 100;
			// Get the reservation status
			$status = $datapdo->get_one("SELECT `status` FROM `".TABLE_PREFIX."reservations` WHERE `res_id`='$res_id' LIMIT 1");
			$table1 = "`".TABLE_PREFIX."resbilling_detail`";
			$table2 = "`".TABLE_PREFIX."resbilling_sdetail`";
			// Check the commission is allready calculated
			$query1 = "SELECT `commission`,`deleted` FROM $table1 WHERE `res_id`='$res_id'";
			$query2 = "SELECT `sbilling_id`,`commission` FROM $table2 WHERE `res_id`='$res_id' LIMIT 0,1";
			$get_prov = $datapdo->query($query1);
			if($datapdo->numRows($get_prov)>0){
				$iscalc = true;
				while($comm = $datapdo->fetchRow($get_prov)){
					$commission_price += $comm['commission'];
					$fullcommprice = $commission_price;
					if($comm['deleted'] == 1){
						$get_prov2 = $datapdo->query($query2);
						if($datapdo->numRows($get_prov2)>0){
							$scomm = $datapdo->fetchRow($get_prov2);
							$currsbilling = $scomm['sbilling_id'];
							$commission_price -= $scomm['commission'];
							$isprinted = $datapdo->get_one("SELECT `bil_date` FROM `".TABLE_PREFIX."resbilling_storno` WHERE `sbilling_id`='$currsbilling' LIMIT 1");
							$sbillingid = ($isprinted > 0?0:$currsbilling);
							$numeral = ($sbillingid > 0?true:false);
						}
					}
				}
			}
			else{
				// If commission must be calculated
				$commids_sql = '';
				$is_fix = false;
				$reduce_price = 0;
				$reduce_commids = '';
				$rabatt = 0;
				$norabat = 0;
				if($status > 0){
					$query1 = "SELECT `fixed_price` FROM `".TABLE_PREFIX."res_price_calc` WHERE `object_id`='$object_id' AND `res_id`='$res_id' AND `fixed_price`>'0' LIMIT 0,1";
					// If the commission will be calculated with special price
					if($datapdo->numRows($datapdo->query($query1))>0){ $is_fix = true; };

					$query2 = "SELECT `pricetab_id` FROM `".TABLE_PREFIX."resbilling_obj` WHERE `object_id`='$object_id' AND `commission_type`='1'";
					$get_commtabs = $datapdo->query($query2);
					if($datapdo->numRows($get_commtabs)>0){
						while($commtabs = $datapdo->fetchRow($get_commtabs)){
							$findid = $commtabs['pricetab_id'];
							$commids_sql .= ($commids_sql == ''?" AND (":" OR ")."`item_id`".(($findid == 'SEASON' OR $findid == 'HOLI')?" LIKE ":" = ")."'".$findid.(($findid == 'SEASON' OR $findid == 'HOLI')?"%":"")."'";
						}
						$commids_sql .= ($is_fix==true?" OR `item_id`='SPECIAL'":"").")".($is_fix==true?" AND `fix`='1'":" AND `fix`='0'");
					}
					if($commids_sql != ''){
						$query3 = "SELECT `item_id`,`single_price`,`quantity`,`external` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id'".$commids_sql." AND `external`='0'";
						$get_tabprices = $datapdo->query($query3);
						if($datapdo->numRows($get_tabprices)>0){
							while($comm = $datapdo->fetchRow($get_tabprices)){
								$price = $comm['single_price']*$comm['quantity'];
								$commission_price += $price;
								$checkitem = substr($comm['item_id'],0,4);
								if($checkitem != 'SEAS' AND $checkitem != 'SPEC' AND $checkitem != 'HOLI'){ $norabat += $price; }
							}
							if($is_fix==true){
								// reduce the commision with add prices without commission if we have a fix price
								$queryADDS2 = "SELECT `pricetab_id` FROM `".TABLE_PREFIX."resbilling_obj` WHERE `object_id`='$object_id' AND `commission_type`='0'";
								$get_adds2 = $datapdo->query($queryADDS2);
								if($datapdo->numRows($get_adds2)>0){
									while($adds2 = $datapdo->fetchRow($get_adds2)){
										$adds2id = $adds2['pricetab_id'];
										$reduce_commids .= ($reduce_commids==''?" AND (":" OR ")."`item_id`".($adds2id=='HOLI'?" LIKE ":" = ")."'".$adds2id.($adds2id=='HOLI'?"%":"")."'";
									}
									$reduce_commids .= ")";
								}
							}
						}
						if($reduce_commids != ''){
							$get_noprov_prices = $datapdo->query("SELECT `item_id`,`single_price`,`quantity` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id' AND `fix`='0'".$reduce_commids);
							if($datapdo->numRows($get_noprov_prices)>0){
								while($findminus = $datapdo->fetchRow($get_noprov_prices)){
									$item = $findminus['item_id'];
									if($datapdo->numRows($datapdo->query("SELECT `invoice_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id' AND `fix`='1' AND `item_id`='$item' AND `single_price`='0' LIMIT 0,1"))>0){
										$minusprice = $findminus['single_price']*$findminus['quantity'];
										$commission_price -= $minusprice;
									}
								}
							}
						}
						$commission_price=$commission_price*$commission;
						if($is_fix == false){
							$get_rabatts = $datapdo->query("SELECT `quantity` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$res_id' AND (`item_id`='DISC_1' OR `item_id`='DISC_2' OR `item_id`='DISC_3')");
							if($datapdo->numRows($get_rabatts)>0){
								while($rabatts = $datapdo->fetchRow($get_rabatts)){
									$rabatt += ($rabatts['quantity']/100);
								}
							}
						}
						if($rabatt > 0){ $commission_price -= (($commission_price-$norabat) * $rabatt); }
					}
				}
				else{
					$stornoprices = $datapdo->get_one("SELECT `storno_price` FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$res_id' LIMIT 1");
					$fullcommprice = $stornoprices*$commission_storno;
					$commission_price = $fullcommprice;
				}
			}
		}
		if($commission_price > 0){
			if($fullcommprice <> $commission_price AND $sbillingid > 0){ $commission_price = $fullcommprice; }
			if($roundprice==1){ $commission_price=round(($commission_price*2),1)/2; }
			if($numeral == true){ $retarray = array($commission_price,$iscalc,$sbillingid); }
			else{ $retarray = array($TEXT['COMMISSION'].' - '.($iscalc == true?$TEXT['COMMISSION_CALC']:$TEXT['COMMISSION_PRE']).':&nbsp;'.number_format($commission_price,2,$dec_point,$thousends).'&nbsp;'.$TEXT['PRICE_UNIT'][$unit]); }
		}
	}
	return $retarray;
}
function get_preprice($obj_id,$tprice,$resid=0,$extprices=0,$checkroundrange=false){
	global $datapdo;
	$preprice = 0;
	$oldpreprice = 0;
	$roundpre = false;
	// Check we have a saved preprice
	if($resid > 0){
		$get_oldpre = $datapdo->query("SELECT `pre_price`,`total_price`,`fixed_price` FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$resid' AND (`total_price`='$tprice' OR `fixed_price`='$tprice') LIMIT 0,1");
		if($datapdo->numRows($get_oldpre)>0){
			$oldpre = $datapdo->fetchRow($get_oldpre);
			$oldpreprice = $oldpre['pre_price'];
		}
		else{
			if($checkroundrange==true){
				$roundpre_date = mktime(0,0,0,6,25,2020);
				$roundpre2_date = time();
				$resdate = $datapdo->query("SELECT `log_when` FROM `".TABLE_PREFIX."reservations` WHERE `res_id`='$resid' AND `log_when`>'$roundpre_date' AND `log_when`<'$roundpre2_date' LIMIT 0,1");
				if($datapdo->numRows($resdate)>0){ $roundpre = true; }
			}
		}
	}
	if($oldpreprice > 0){ $preprice = $oldpreprice; }
	else{
		$get_preset = $datapdo->query("SELECT `preprice`,`pretype`,`roundprice` FROM `".TABLE_PREFIX."res_price_sets` WHERE `object_id`='$obj_id' LIMIT 0,1");
		if($datapdo->numRows($get_preset)>0){
			$preset = $datapdo->fetchRow($get_preset);
			if($preset['preprice'] < 1){
				$preprice = $tprice*$preset['preprice'];
				if($preset['pretype'] > 1){
					if($resid > 0){ $minusadds = get_alladds($resid); }
					else{ $minusadds = $extprices; }
					$preprice = ($tprice-$minusadds)*$preset['preprice'];
				}
//				$preprice = round(($preprice*2),1)/2;
				if($preset['roundprice']==1 OR $roundpre == true){ $preprice = round(($preprice*2),1)/2; }
			}
			elseif($preset['preprice'] > $tprice){ $preprice = $tprice; }
			else{ $preprice = $preset['preprice']; }
		}
	}
	if($resid > 0 AND $preprice > 0){ // AND $oldpreprice == 0){
		$datapdo->query("UPDATE `".TABLE_PREFIX."res_price_calc` SET `pre_price`='$preprice' WHERE `res_id`='$resid' LIMIT 1");
	}
	return $preprice;
}
function get_prepricedate($obj_id,$res_id){
	global $datapdo;
	$predate = '';
	$get_predateset = $datapdo->query("SELECT `days_pre`,`base_pre` FROM `".TABLE_PREFIX."res_paymentset` WHERE `object_id`='$obj_id' LIMIT 0,1");
	if($datapdo->numRows($get_predateset)>0){
		$predateset = $datapdo->fetchRow($get_predateset);
		if($predateset['base_pre'] > 0){
			$predays = $predateset['days_pre']*86400;
			$get_basedates = $datapdo->query("SELECT `log_when`,`res_start`,`res_end` FROM `".TABLE_PREFIX."reservations` WHERE `res_id`='$res_id' LIMIT 1");
			$basedates = $datapdo->fetchRow($get_basedates);
			switch ($predateset['base_pre']){
				case 3:
					$basedate = $basedates['res_end'];
					break;
				case 2:
					$basedate = $basedates['res_start'];
					break;
				case 1:
					$basedate = $basedates['log_when'];
					break;
			}
			$predatecalc = $basedate + $predays;
			$predate = date(DATE_FORMAT,$predatecalc);
		}
	}
	return $predate;
}
if(!function_exists('check_is_belcal')){
	function check_is_belcal($oid){
		global $datapdo;
		$get_cal_sect = $datapdo->query("SELECT `section_id`,`active` FROM `".TABLE_PREFIX."sections` WHERE `module`='calendar' AND `object_id`='$oid'");
		if($datapdo->numRows($get_cal_sect)>0){
			$cal_sect = $datapdo->fetchRow($get_cal_sect);
			$return_array = array($cal_sect['section_id'],$cal_sect['active']);
			return $return_array;
		}
		else{
			return false;
		}
	}
}
if(!function_exists('get_storno_price')){
	function get_storno_price($object,$sw=0,$os=0,$ob=0){
		global $datapdo;
		$ret = array(0,0);
		if($os == 0){ return $ret; }
		if($sw == 0){ $sw = time(); }
		$query_storno_set = "SELECT `days_storno`,`base_storno`,`price_storno`,`unit_storno`,`days_storno2`,`base_storno2`,`price_storno2`,`unit_storno2`,`days_storno3`,`base_storno3`,`price_storno3`,`unit_storno3` FROM `".TABLE_PREFIX."res_paymentset` WHERE `object_id`='$object' AND `paycontrol`='1' AND (`price_storno`>'0' OR `price_storno2`>'0' OR `price_storno3`>'0') LIMIT 0,1";
		$get_storno_set = $datapdo->query($query_storno_set);
		if($datapdo->numRows($get_storno_set)>0){
			$storno_set = $datapdo->fetchRow($get_storno_set);
			$unit_storno = $storno_set['unit_storno'];
			$base_storno = $storno_set['base_storno'];
			$offset_storno = $storno_set['days_storno']*86400;
			$base_storno2 = $storno_set['base_storno2'];
			$offset_storno2 = $storno_set['days_storno2']*86400;
			$base_storno3 = $storno_set['base_storno3'];
			$offset_storno3 = $storno_set['days_storno3']*86400;
			switch ($base_storno){
				case 1: $date_storno_dead = $ob+$offset_storno; break;
				case 2: $date_storno_dead = $os+$offset_storno; break;
				case 0:
				default:
					$date_storno_dead = 0;
					break;
			}
			switch ($base_storno2){
				case 1: $date_storno_dead2 = $ob+$offset_storno2; break;
				case 2: $date_storno_dead2 = $os+$offset_storno2; break;
				case 0:
				default:
					$date_storno_dead2 = 0;
					break;
			}
			switch ($base_storno3){
				case 1: $date_storno_dead3 = $ob+$offset_storno3; break;
				case 2: $date_storno_dead3 = $os+$offset_storno3; break;
				case 0:
				default:
					$date_storno_dead3 = 0;
					break;
			}
			$price_storno = 0;
			if($sw >= $date_storno_dead){
				$unit_storno = $storno_set['unit_storno'];
				$price_storno = $storno_set['price_storno'];
			}
			if($sw >= $date_storno_dead2){
				$unit_storno = $storno_set['unit_storno2'];
				$price_storno = $storno_set['price_storno2'];
			}
			if($sw >= $date_storno_dead3){
				$unit_storno = $storno_set['unit_storno3'];
				$price_storno = $storno_set['price_storno3'];
			}
			$roundprice = $datapdo->get_one("SELECT `roundprice` FROM `".TABLE_PREFIX."res_price_sets` WHERE `object_id`='$object' LIMIT 1");
			if($roundprice == 1){ $price_storno = round(($price_storno*2),1)/2; }else{ $price_storno = round($price_storno,2); }
			$ret = array($unit_storno,$price_storno);
		}
		return $ret;
	}
}
if(!function_exists('get_external')){
	function get_external($id){
		global $datapdo;
		$price = 0;
		$query_extprices = "SELECT `quantity`,`single_price` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$id' AND `external`='1'";
		$get_extprices = $datapdo->query($query_extprices);
		if($datapdo->numRows($get_extprices)>0){
			while($extprices = $datapdo->fetchRow($get_extprices)){
				$tmppr = $extprices['single_price'] * $extprices['quantity'];
				$price = $price + $tmppr;
			}
		}
		return $price;
	}
}
function get_alladds($id){
	global $datapdo;
	$price = 0;
	$get_addsprices = $datapdo->query("SELECT `quantity`,`single_price` FROM `".TABLE_PREFIX."res_invoice` WHERE `res_id`='$id' AND `external`='0' AND `fix`='0' AND (`item_id` LIKE 'ADDS%' OR `item_id` LIKE 'MORE%')");
	if($datapdo->numRows($get_addsprices)>0){
		while($addsprices = $datapdo->fetchRow($get_addsprices)){
			$tmppr = $addsprices['single_price'] * $addsprices['quantity'];
			$price = $price + $tmppr;
		}
	}
	return $price;
}
?>